//***************************************************************
// dirview.h
//***************************************************************
/***************************************************************************
                          dirview.h  -  description
                             -------------------
    begin                : Sun Nov 7 1999
    copyright            : (C) 1999 by delta_x
    email                : delta_x@linuxcoding.de
 ***************************************************************************/

#ifndef DIRVIEW_H
#define DIRVIEW_H

#include <qwidget.h>
#include <qpainter.h>
#include <qstring.h>
#include <qpixmap.h>
#include <qscrollbar.h>
#include <listview.h>


struct	dirviewItem{
	QString text;
	QString path;
	int			expandable;	// 0 NEIN 1 expandiert, 2 geschlossen
	dirviewItem *nextEntry;
	dirviewItem *prevEntry;
	int			tabValue;
};


/**
  *@author delta_x
  */

class dirview : public QWidget  {
   Q_OBJECT
public: 
	dirview(listView *LV, const char *dirpath, QWidget *parent=0, const char *name=0);
	~dirview();

protected:
	listView		*lv;
	dirviewItem *itemWithFocus;
	dirviewItem	*Liste;
	dirviewItem *addItem(const char *text,const char *path);
	QPixmap 		*pmMinus;
	QPixmap 		*pmPlus;
	QPixmap 		*pmLeer;
	QPixmap 		*pmFirstCorner;
	QPixmap 		*pmSenk;
	QPixmap 		*pmWaage;
	QPixmap 		*pmKreuz;
	
	dirviewItem *firstVisibleItem,
					*lastVisibleItem;
	QPixmap		*pmBuffer;
	int			maxVisibleItems;
	void 			readDir(dirviewItem *dv);
	QScrollBar	*horSlider,
					*verSlider;
	bool			checkDir(int i,dirviewItem *di);
	void			rechne();
	void			refresh();
private slots:
	void			paintEvent(QPaintEvent *);
	void			resizeEvent(QResizeEvent *e);
	void			hchanged(int i);
	void			vchanged(int i);
	void			mouseDoubleClickEvent ( QMouseEvent * );
	void			mousePressEvent ( QMouseEvent * );
signals:
	void 			dirSelected(const char *);
};

#endif
