#include "dlgdel.h"
#include "iostream.h"

bool allDelete;

dlgDel::dlgDel(
						listView *S,
						listView *D,
					   const char *SP,
					   const char *DP,
						QWidget *parent,
						const char *name) : QDialog(parent,name,true){
	main = parent;
	Source = S;		
	Dest 	 = D;
	SourcePath = SP;
	DestPath = DP;
	
	abbruch = false;
	
	initDialog();
	init();
	startTimer(100);
}

void dlgDel::init()
{
   	KCommanderApp *m = (KCommanderApp *) main;
		if(optionen::askDelete()==false)
		   allDelete = true;
		else
		   allDelete = false;

		if(Source->itemsSelected() == 0)
		{
				delDir(QString(m->netPathToRealPath(SourcePath)) + *Source->lastItemClicked->text[0]);
		}
		else
		{
			listItem *li = Source->Liste->next;
			while(li != 0)
			{
				if(li->selected)
					delDir(QString(m->netPathToRealPath(SourcePath)) + *li->text[0]);
				li = li->next;
				if(abbruch == true) break;
			}
		}
}

void	dlgDel::timerEvent(QTimerEvent *t)
{
  QString labText;
	killTimers();
	int counter = 0;
	ProgressBar->setValueRange(0,stack.count());
	
	while(!stack.isEmpty())
	{
		kapp->processEvents();
			
		// Hole zu lschenden Namen (Dir/File)
		QDir deldir(stack.getLast());
		// ist es ein Dir ??
		if (deldir.exists())
		{
 		if(optionen::askDelete() == true && allDelete == false )
			{
  			   km = new KMsgBox ((QWidget*)this, stack.getLast(),
                       i18n("Confirm delete of Dir ?\n"),(KMsgBox::QUESTION | KMsgBox::DB_FIRST),
                      i18n("&Yes"),
                      i18n("&All"),
                      i18n("&No"),
                      i18n("&Cancel"));

  			   // ging file zu lschen ?
  			   // ja, weitermachen
  			   // nein:
  			   // Wiederholen, Abbrechen, Ignorieren
 						
  			   int frage = km->exec();
						// Yes, return ?						
 		    		if(frage == 1)
	   		      removeDir(stack.getLast());
						// All ?
	     			else if(frage == 2)
	     			 	{
					   	allDelete = true;
	    		   	removeDir(stack.getLast());
			       	}
						// No ?
 		    		else if(frage == 3)
		     			stack.removeLast();
						// Cancel, ESC ?
						else
		     			stack.clear();

					if(km)
					{
					   delete km;
					   km = 0;
					}
			}
			else
    		  removeDir(stack.getLast());

		}
			// oder doch ein file !!
  		else
  		{
  			if(optionen::askDelete() == true && allDelete == false)
  			{
  		      km = new KMsgBox ((QWidget*)this, i18n("Delete ")+QString(stack.getLast()),
  	                                     i18n("Confirm delete of file ?\n"),(KMsgBox::QUESTION | KMsgBox::DB_FIRST),
                                          i18n("&Yes"),
                                          i18n("&All"),
                                          i18n("&No"),
                                          i18n("&Cancel"));

				   int frage = km->exec();
						// Yes, return ?						
 		    		if(frage == 1)
	   		      removeFile(stack.getLast());
						// All ?
	     			else if(frage == 2)
	     			 	{
					   	allDelete = true;
	    		   	removeFile(stack.getLast());
			       	}
						// No ?
 		    		else if(frage == 3)
		     			stack.removeLast();
						// Cancel, ESC ?
						else
		     			stack.clear();

 					if(km)
 					{
 					   delete km;
 					   km = 0;
 					}
  			}
  			else
   		      removeFile(stack.getLast());
  		}
  		// nach lschen auf jedenfall noch ...
  		dellabel->setText(i18n("Delete  ")+QString(stack.getLast()));
  		counter ++;
  		ProgressBar->setValue(counter);
  		if(abbruch == true)
  		   break;
  	}
		
	KCommanderApp *m = (KCommanderApp *) main;
	m->readDir(SourcePath, Source);			// und ListView refreshen
	if(Source->dirPath == Dest->dirPath)
		m->readDir(SourcePath, Dest);
	close();	
	
}

void dlgDel::delDir(QString ldir)
{
	QDir neu;
	QFile delfile;
	neu.setPath(ldir);

	if(!neu.exists())   //fr den Fall, das es nur ein File ist
		{
			stack.append(ldir);
			return;
		}
	else
	   stack.append(ldir);  // ansonsten Hauptdirectory einbauen !!
	
	if ( !neu.isReadable() )
	   return;
		
	neu.setSorting(QDir::Name | QDir::DirsFirst | QDir::IgnoreCase);
	neu.setFilter(QDir::Files | QDir::Dirs | QDir::Hidden);

   const QFileInfoList * files = neu.entryInfoList();
   if ( files )
   {
      QFileInfoListIterator it( *files );
      QFileInfo * f;
      while( (f=it.current()) != 0 )
      {
         ++it;
         if ( f->fileName() == "." || f->fileName() == ".." )
         {
         }
         else
         {
            if ( f->isDir())
            {
               QString fg = ldir + "/" + f->fileName();
    	         delDir(fg);
            }
            else
            {
           	   delfile.setName(ldir + "/" + f->fileName());
              	stack.append(delfile.name());
            }
         }
		}
	}
}

void  dlgDel::initDialog(){
	ProgressBar = new myProgress(0,99,0,myProgress::Horizontal,this,"Balken1");
	ProgressBar->setGeometry(10,60,400,20);
	ProgressBar->setBarColor(darkBlue);
	
	dellabel = new QLabel(this,"Delete");
	dellabel->setGeometry(10,20,400,20);
	
	cancelBtn = new QPushButton(i18n("Cancel"),this);
	cancelBtn->setGeometry(160,90,100,30);
  connect(cancelBtn,SIGNAL(clicked()),SLOT(cancelPressed()));
  	
  this->resize(420,130);
  this->setMinimumSize(100,10);

}

void dlgDel::cancelPressed()
{
   abbruch = true;
   accept();
}

dlgDel::~dlgDel()
{
	delete ProgressBar;
	delete cancelBtn;
	delete dellabel;
}

bool dlgDel::removeDir(const char*dir)
{
   bool deleted;
   int a;

   QDir Dir(dir);
   deleted = Dir.rmdir(dir);
   // konnte dir gelscht werden ? nein ? dann rein in die whileloop
   while(!deleted)
   {
      a = ask(dir);
      switch(a)
      {
         case 1:        // RETRY
            break;
         case 2:        // IGNORE
            deleted = true;
            break;
         case 3:        // CANCEL
  				if(km)
  				{
  				   delete km;
  				   km = 0;
  				}
    			stack.clear();
            return false;
            break;
      }  // end of switch
   }   // end of while
	stack.removeLast();
   return true;
}

bool dlgDel::removeFile(const char*file)
{
   QFile d(file);
m2:
   if(!d.remove())
   {
      switch(ask(file))
      {
         case 1:
            goto m2;
         break;
         case 2:
         break;
         case 3:
  				if(km)
  				{
  				   delete km;
  				   km = 0;
  				}
     			stack.clear();
            return false;
         break;
      }
   }
	stack.removeLast();
   return true;
}

int dlgDel::ask(const char* name)
{
   if(km)
      delete km;
   km = new KMsgBox ((QWidget*)this, stack.getLast(),
                        QString(i18n("Can't delete\n")) + "( " + name + " )",4,
                        i18n("&Retry"),
                        i18n("&Ignore"),
                        i18n("&Cancel"));
   return(km->exec());
}






