#ifndef DLGDEL_H
#define DLGDEL_H

#include <qwidget.h>
#include <qpushbutton.h>
#include <qlabel.h>
#include <qdir.h>
#include <qdialog.h>
#include <qfile.h>
#include <qfileinfo.h>
#include <qstrlist.h>
#include <qmessagebox.h>

#include <kmsgbox.h>

#include "progress.h"
#include "listview.h"
#include "kcommander.h"


class dlgDel : public QDialog  {
   Q_OBJECT
public:
	dlgDel(
				listView *,		// SourceListview, nicht LINKS !
			  listView *,		// DestListview
			  const char *,	// SourcePath
			  const char *,	// DestPath
			  QWidget *parent=0, const char *name=0);
	~dlgDel();
	void init();
	void delDir(QString ldir);
protected:
	QWidget     *main;
	void        initDialog();
	myProgress  *ProgressBar;
	QLabel      *dellabel;
	QPushButton *cancelBtn;
	listView 	*Source,*Dest;
	const char 	*SourcePath, *DestPath;
	bool        abbruch;
	QStrList    stack;
   bool        removeDir(const char*);
   bool        removeFile(const char*);
   int         ask(const char* name);
   KMsgBox     *km;

private slots:
	void        timerEvent(QTimerEvent *t);	
	void        cancelPressed();
private:
};

#endif
