/***************************************************************************
                          dlgeditassigns.cpp  -  description
                             -------------------
    begin                : Tue Jan 18 2000
    copyright            : (C) 2000 by delta_x
    email                : delta_x@linuxcoding.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include "dlgeditassigns.h"

dlgEditAssigns::dlgEditAssigns(QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
	readEntries();

  connect(QPushButton_2,SIGNAL(clicked()),SLOT(CloseApp()));
  connect(QPushButton_1,SIGNAL(clicked()),SLOT(openDirDialog()));
  connect(QLineEdit_1,SIGNAL(returnPressed()),SLOT(newEntered()));
  connect(QListBox_1,SIGNAL(highlighted(const char*)),SLOT(nextSelected(const char*)));
	
	firstSelect();
}

dlgEditAssigns::~dlgEditAssigns()
{
	newEntered();
}

void dlgEditAssigns::CloseApp()
{
	close();
}

void dlgEditAssigns::readEntries()
{
	QListBox_1->clear();
	
	KConfig *config = kapp->getConfig();
	config->setGroup("Assignments");

  QString l,s,t;
  for(int i = 'A'; i <= 'Z';i++)
  {
      l.sprintf("%c",i);
      l += " - ";
				t.sprintf("DriveAssign%c",i);	
				s = config->readEntry(t,"");
			l += s;
      QListBox_1->insertItem(l);
  }

  	autoFocus=true;
}

void dlgEditAssigns::firstSelect()
{
	QString s;
	KConfig *config = kapp->getConfig();
	config->setGroup("Assignments");	
	s = config->readEntry("DriveAssignA","");
	QLineEdit_1->setText(s);
}

void dlgEditAssigns::nextSelected(const char* item)
{
	if(autoFocus)QLineEdit_1->setFocus();
	QString s,t,u;
	u.sprintf(item);
 	u = u.left(1);
	KConfig *config = kapp->getConfig();
	config->setGroup("Assignments");
		
		t.sprintf("DriveAssign%s",(const char*)u);	
		s = config->readEntry(t,"");
	
	QLineEdit_1->setText(s);
}

void dlgEditAssigns::newEntered()
{
	QString s,t,u;
		
		KConfig *config = kapp->getConfig();
		config->setGroup("Assignments");
	u.sprintf(QListBox_1->text(QListBox_1->currentItem()));
 	u = u.left(1);
	s.sprintf("DriveAssign%s",(const char*)u);
	t = QLineEdit_1->text();
	if(t.right(1) == "/")
   	t = t.left(t.length()-1);

  if(t.left(1) != "/" && t.length() != 0)
  	t = "/"+t;
	
	if(QListBox_1->currentItem() != -1)
		config->writeEntry(s,t);
	config->sync();
	
	readEntries();
}

void dlgEditAssigns::openDirDialog()
{
	if(QListBox_1->currentItem() == -1) return;
	QString s;
	s = dirselect->KFileBaseDialog::getDirectory("/",this,"no Name");
	QLineEdit_1->setText(s);
	newEntered();	
}

void dlgEditAssigns::keyPressEvent(QKeyEvent *e)
{
	QListBox_1->setSmoothScrolling(true);
	QString s;
	s.sprintf("%x",e->key());
//	debug(s);
	switch(e->key())
	{
		case 0x1015:
			if((QListBox_1->currentItem()+1) < (signed int)QListBox_1->count())
				QListBox_1->setCurrentItem(QListBox_1->currentItem()+1);
			if((QListBox_1->currentItem())> QListBox_1->numItemsVisible()-1)
				QListBox_1->setTopItem(5);
			break;
		case 0x1013:
		  if((QListBox_1->currentItem()-1) >= 0)
				QListBox_1->setCurrentItem(QListBox_1->currentItem()-1);
			if((QListBox_1->currentItem()) < 5)
				QListBox_1->setTopItem(0);
			break;
		case 0x1039:
			accept();
			break;
	}
}
