#include "dlgedittoolbar.h"
#include <stdlib.h>
#include "up.xpm"
#include <kiconloader.h>
#include <kiconloaderdialog.h>

//#define DEBUGWINDOW 1

dlgEditToolBar::dlgEditToolBar(QWidget *parent, const char *name) : QDialog(parent,name,true){
	setCaption(" ");
	initDialog();
	config = kapp->getConfig();

#ifdef DEBUGWINDOW
   debugWindow = new QWidget();
   debugWindow->setGeometry(0,0,300,600);
   debugWindow->show();
   for(int i=0;i<99;i++)
   {
      debugLabel[i] = new QLabel(debugWindow);
      debugLabel[i]->show();
      debugLabel[i]->setGeometry(10,10 +i*20,100,20);
      debugWerte[i] = new QLabel(debugWindow);
      debugWerte[i]->show();
      debugWerte[i]->setGeometry(150,10 +i*20,100,20);
   }
//   startTimer(100);
#endif
	
   connect(btAdd,SIGNAL(clicked()),SLOT(onAddClicked()));
   connect(btLeft,SIGNAL(clicked()),SLOT(onLeftClicked()));
   connect(btRight,SIGNAL(clicked()),SLOT(onRightClicked()));
   connect(btDelete,SIGNAL(clicked()),SLOT(onDeleteClicked()));
   connect(btIcon,SIGNAL(clicked()),SLOT(onIconClicked()));
   connect(btClose,SIGNAL(clicked()),SLOT(accept()));
   connect(btKCommand,SIGNAL(clicked()),SLOT(onKCommandClicked()));

	editParam->setName("p");
	editCommand->setName("c");
	editTooltip->setName("t");
   connect(editParam,SIGNAL(textChanged(const char *)),SLOT(saveIconData()));
   connect(editCommand,SIGNAL(textChanged(const char *)),SLOT(saveIconData()));
   connect(editTooltip,SIGNAL(textChanged(const char *)),SLOT(saveIconData()));
   connect(paramList,SIGNAL(activated ( int )),SLOT(paramSelected(int)));
   QPushButton *bt;  // tempbutton !	
   	
// read in the configurated toolbuttons

   int button = 0;      // begin with button 0
   bool ready = false;  // the READY-Flag
   QString s,Image, Exec, Param, Tooltip;
   QString btName;
   sc = new QScrollView(this);      // the scrollview
   sc->viewport()->setBackgroundColor(backgroundColor());
   sc->setGeometry(10,90,400,80);

   pfeil = new QPixmap((const char **)up);
   QString d = kapp->kde_icondir() + "/";
   btPfeil = new QPushButton();
   btPfeil->resize(20,20);
   btPfeil->setPixmap(*pfeil);
   btPfeil->setName("");
   	
   while(!ready)
   {
      // if no button follows we set ready to TRUE
		config = kapp->getConfig();
      config->setGroup("Toolbuttons");

      s.sprintf("btImage%d",button);
   	Image = config->readEntry(s,"");

      s.sprintf("btExec%d",button);
   	Exec = config->readEntry(s,"");

      s.sprintf("btParam%d",button);
   	Param = config->readEntry(s,"");

      s.sprintf("btTooltip%d",button);
   	Tooltip = config->readEntry(s,"");
   	
   	if(Image == "")
   	{
   	   ready = true;
   	}
   	else
   	{
   	   // add new Button
         buttons[button] = new toolButtonInfo;
         buttons[button]->btImagePath  = Image;
         buttons[button]->btExec       = Exec;
         buttons[button]->btParam      = Param;
         buttons[button]->btToolTip    = Tooltip;

         bt = new QPushButton();
         pushButtons[button] = bt;
         pushButtons[button+1] = 0;
         bt->resize(40,40);
      	
      	 KIconLoader kil;

         bt->setPixmap(kil.loadIcon(Image,32,32));
         btName.sprintf("%d",button);
         bt->setName(btName);
         connect(bt,SIGNAL(clicked()),SLOT(buttonClicked()));
         sc->addChild(bt,button * 40,0);
   	}
   	button++;
   }
   btCount = button-1;
   currentBT = 0;
   sc->addChild(btPfeil,currentBT*40+10,40);

   for(int i=0;i<99;i++)
      buttons[i] = 0;

	if(btCount)
		fillOutEdits(0);

	kcPopup = new KPopupMenu(i18n("select a command"));
//  id = QPopupMenu_1->insertItem(i18n("Quit..."),this,SLOT(menuPressed()), 0,10010);

	kcPopup->insertItem(	i18n("Reach the Network"));
	kcPopup->insertItem(	i18n("Change Listviews"));
	kcPopup->insertItem(	i18n("Show/Hide DiscUsage"));
	kcPopup->insertItem(	i18n("Read Directory (Parameter = Path)"));
	kcPopup->insertItem(	i18n("Edit File (Parameter!)"));
	kcPopup->insertItem(	i18n("Show File (Parameter!)"));
	kcPopup->insertItem(	i18n("Quit KCommander"));

   connect(kcPopup,SIGNAL(activated(int)),this,SLOT(popupSelected ( int )));
}

dlgEditToolBar::~dlgEditToolBar()
{
#ifdef DEBUGWINDOW
   delete debugWindow;
#endif
}
void dlgEditToolBar::buttonClicked()
{
   int bt = atoi(sender()->name());
   sc->moveChild((QWidget *)btPfeil,bt*40+10,40);
   currentBT = bt;
#ifdef DEBUGWINDOW
   debugLabel[2]->setText("ButtonClicked");
   debugWerte[2]->setText(sender()->name());
#endif
   fillOutEdits(bt);
}
//*******************************************************************************
void  dlgEditToolBar::fillOutEdits(int button)
{
   QString s,Image, Exec, Param, Tooltip;
	
	config = kapp->getConfig();

	config->setGroup("Toolbuttons");

  	s.sprintf("btExec%d",button);
	Exec = config->readEntry(s,"");
  	editCommand->setText(Exec);
	
  	s.sprintf("btParam%d",button);
	Param = config->readEntry(s,"");
  	editParam->setText(Param);

  	s.sprintf("btTooltip%d",button);
	Tooltip = config->readEntry(s,"");
  	editTooltip->setText(Tooltip);
}
void  dlgEditToolBar::resizeEvent(QResizeEvent *)
{
  sc->resizeContents( btCount * 40 ,60);
}
void  dlgEditToolBar::paintEvent(QPaintEvent *)
{
  sc->resizeContents( btCount * 40 ,60);
}
void  dlgEditToolBar::onLeftClicked()
{
   if(!currentBT) return;           // left button could not move to the left
//************************************************************************
   QString s;
   QString Image,  Exec,  Param,  Tooltip;   // Strings of current Button
   QString tImage, tExec, tParam, tTooltip;  // Strings
   int button = currentBT;
	config->setGroup("Toolbuttons");
   s.sprintf("btImage%d",button);
	Image = config->readEntry(s,"");
   s.sprintf("btExec%d",button);
	Exec = config->readEntry(s,"");
   s.sprintf("btParam%d",button);
	Param = config->readEntry(s,"");
   s.sprintf("btTooltip%d",button);
	Tooltip = config->readEntry(s,"");

   s.sprintf("btImage%d",button-1);
	tImage = config->readEntry(s,"");
   s.sprintf("btExec%d",button-1);
	tExec = config->readEntry(s,"");
   s.sprintf("btParam%d",button-1);
	tParam = config->readEntry(s,"");
   s.sprintf("btTooltip%d",button-1);
	tTooltip = config->readEntry(s,"");

   s.sprintf("btImage%d",button);
	  config->writeEntry(s,tImage);
   s.sprintf("btExec%d",button);
	  config->writeEntry(s,tExec);
   s.sprintf("btParam%d",button);
	  config->writeEntry(s,tParam);
   s.sprintf("btTooltip%d",button);
	  config->writeEntry(s,tTooltip);

   s.sprintf("btImage%d",button-1);
	  config->writeEntry(s,Image);
   s.sprintf("btExec%d",button-1);
	  config->writeEntry(s,Exec);
   s.sprintf("btParam%d",button-1);
	  config->writeEntry(s,Param);
   s.sprintf("btTooltip%d",button-1);
	  config->writeEntry(s,Tooltip);
	  config->sync();
//************************************************************************
   int x1 = pushButtons[currentBT]->x();     // x of the sourcebutton
   int x2 = pushButtons[currentBT-1]->x();   // x of the destbutton

   sc->moveChild(pushButtons[currentBT],x2,0);
   sc->moveChild(pushButtons[currentBT-1],x1,0);

   // swap the name of the buttons
   QString s1= pushButtons[currentBT]->name();
   QString s2= pushButtons[currentBT-1]->name();
   pushButtons[currentBT]->setName(s2);
   pushButtons[currentBT-1]->setName(s1);
   //move the arrow to leftside
   sc->moveChild(btPfeil,btPfeil->x()-40,40);

   // swap the buttonlist-pointers
   QPushButton *temp = pushButtons[currentBT];
   pushButtons[currentBT] = pushButtons[currentBT-1];
   pushButtons[currentBT-1] = temp;

   currentBT--;
}
void  dlgEditToolBar::onRightClicked()
{
   if((currentBT+1) >= btCount) return;  // right button could not move to the right
//************************************************************************
   QString s;
   QString Image,  Exec,  Param,  Tooltip;   // Strings of current Button
   QString tImage, tExec, tParam, tTooltip;  // Strings
   int button = currentBT;
	config->setGroup("Toolbuttons");
   s.sprintf("btImage%d",button);
	Image = config->readEntry(s,"");
   s.sprintf("btExec%d",button);
	Exec = config->readEntry(s,"");
   s.sprintf("btParam%d",button);
	Param = config->readEntry(s,"");
   s.sprintf("btTooltip%d",button);
	Tooltip = config->readEntry(s,"");

   s.sprintf("btImage%d",button+1);
	tImage = config->readEntry(s,"");
   s.sprintf("btExec%d",button+1);
	tExec = config->readEntry(s,"");
   s.sprintf("btParam%d",button+1);
	tParam = config->readEntry(s,"");
   s.sprintf("btTooltip%d",button+1);
	tTooltip = config->readEntry(s,"");

   s.sprintf("btImage%d",button);
	  config->writeEntry(s,tImage);
   s.sprintf("btExec%d",button);
	  config->writeEntry(s,tExec);
   s.sprintf("btParam%d",button);
	  config->writeEntry(s,tParam);
   s.sprintf("btTooltip%d",button);
	  config->writeEntry(s,tTooltip);

   s.sprintf("btImage%d",button+1);
	  config->writeEntry(s,Image);
   s.sprintf("btExec%d",button+1);
	  config->writeEntry(s,Exec);
   s.sprintf("btParam%d",button+1);
	  config->writeEntry(s,Param);
   s.sprintf("btTooltip%d",button+1);
	  config->writeEntry(s,Tooltip);
	  config->sync();
//************************************************************************
   int x1 = pushButtons[currentBT]->x();     // x of the sourcebutton
   int x2 = pushButtons[currentBT+1]->x();   // x of the destbutton

   sc->moveChild(pushButtons[currentBT],x2,0);
   sc->moveChild(pushButtons[currentBT+1],x1,0);

   // swap the name of the buttons
   QString s1= pushButtons[currentBT]->name();
   QString s2= pushButtons[currentBT+1]->name();
   pushButtons[currentBT]->setName(s2);
   pushButtons[currentBT+1]->setName(s1);
   //move the arrow to leftside
   sc->moveChild(btPfeil,btPfeil->x()+40,40);

   // swap the buttonlist-pointers
   QPushButton *temp = pushButtons[currentBT];
   pushButtons[currentBT] = pushButtons[currentBT+1];
   pushButtons[currentBT+1] = temp;

   currentBT++;
}
//************************************************************************
//************************************************************************
void  dlgEditToolBar::onDeleteClicked()
{
   if(btCount < 1)
      return;
   // first remove the button
   int x = pushButtons[currentBT]->x();      // remember the x-position


   sc->removeChild(pushButtons[currentBT]);
   delete pushButtons[currentBT];
   pushButtons[currentBT] = 0;

   btCount--;
  	config->setGroup("Toolbuttons");
   QString n1,n2,s;
   QString Image,  Exec,  Param,  Tooltip;   // Strings of current Button

   if(!btCount)
   {
      // all buttons are removed
      // disable the deletebutton,
      // write a "" to the config
      // set the buttonlist to NULL
      // and return
      btDelete->setEnabled(false);
      config->writeEntry("btImage0","");
		config->sync();
   }

   if((currentBT) == btCount)
   {
      sc->moveChild(btPfeil,btPfeil->x()-40,40);
      n1.sprintf("btImage%d",currentBT);   // hierhin wird verschoben
      config->writeEntry(n1,"");
		config->sync();
      currentBT--;
      return;
   }


   // move all following buttons to left
   int i = currentBT +1;
  	
   while(pushButtons[i])
   {
      n1.sprintf("%d",i-1);   // hierhin wird verschoben
      n2.sprintf("%d",i);     // von hier wird verschoben

	config->setGroup("Toolbuttons");
      s = "btImage" + n2;
   	Image = config->readEntry(s,"");
      config->writeEntry(s,"");
      s = "btExec" + n2;
   	Exec = config->readEntry(s,"");
      s = "btParam" + n2;
   	Param = config->readEntry(s,"");
      s = "btTooltip" + n2;
   	Tooltip = config->readEntry(s,"");

      s = "btImage" + n1;
   	config->writeEntry(s,Image);
      s = "btExec" + n1;
   	config->writeEntry(s,Exec);
      s = "btParam" + n1;
   	config->writeEntry(s,Param);
      s = "btTooltip" + n1;
   	config->writeEntry(s,Tooltip);
	  	config->sync();

      sc->moveChild(pushButtons[i],x,0); x += 40;
      pushButtons[i]->setName(n1);
      pushButtons[i-1] = pushButtons[i];
      i++;
   }
   pushButtons[i-1] = 0;
}
void  dlgEditToolBar::onAddClicked()
{
/*
         int button = btCount;
         buttons[button] = new toolButtonInfo;
         buttons[button]->btImagePath  = Image;
         buttons[button]->btExec       = Exec;
         buttons[button]->btParam      = Param;
         buttons[button]->btToolTip    = Tooltip;

         bt = new QPushButton();
         pushButtons[button] = bt;
         pushButtons[button+1] = 0;
         bt->resize(40,40);
*/
   // create a new pushbutton
   pushButtons[btCount] = new QPushButton();
   pushButtons[btCount+1] = 0;
   pushButtons[btCount]->resize(40,40);
   QString btName; btName.sprintf("%d",btCount);
   pushButtons[btCount]->setName(btName);
   connect(pushButtons[btCount],SIGNAL(clicked()),SLOT(buttonClicked()));
   sc->addChild(pushButtons[btCount],btCount * 40,0);
   pushButtons[btCount]->show();
   sc->moveChild(btPfeil,btCount*40+10,40);
   QString s,n1;
   n1.sprintf("%d",btCount);
	
	config->setGroup("Toolbuttons");
   s = "btImage" + n1;
	config->writeEntry(s,"");
   s = "btExec" + n1;
//	debug(s);
	config->writeEntry(s,i18n("<choose a command>"));
   s = "btParam" + n1;
//	debug(s);
	config->writeEntry(s,"<choose parameters>");
   s = "btTooltip" + n1;
//	debug(s);
	config->writeEntry(s,"<here write a info for this button>");
   config->sync();
	
   currentBT = btCount;
   fillOutEdits(btCount++);
//   QMessageBox::information( this, "KCommander Informationbox", i18n("The button will only activated,\nif you select a icon for it !"),0 );
   sc->resizeContents( btCount * 40 ,60);
   sc->setContentsPos(99*40,0);
}
void  dlgEditToolBar::onIconClicked()
{
   KIconLoaderDialog *kildlg;
   kildlg = new KIconLoaderDialog();
	QString s,n1,name,filter;
	QPixmap pm;
	name =""; filter = "*";
	pm = kildlg->selectIcon( name, filter);
  delete kildlg;
	if(name.length())
	{
		KIconLoader *kil = new KIconLoader;
		pm = kil->loadIcon(name,32,32);
	  	pushButtons[currentBT]->setPixmap(pm);

  		config->setGroup("Toolbuttons");
   	s.sprintf("btImage%d",currentBT);
		config->writeEntry(s,name);
	  	config->sync();
		delete kil;
	}
	else
	{
		debug("Icon nicht speichern");
	}
}
void  dlgEditToolBar::onCloseClicked()
{
}
void  dlgEditToolBar::onKCommandClicked()
{
	kcPopup->popup(QPoint(btKCommand->x() + x(),btKCommand->y()+y()));
}
void  dlgEditToolBar::updateScrollview()
{
}
void   dlgEditToolBar::timerEvent(QTimerEvent *e)
{
}

void  dlgEditToolBar::saveIconData()
{
	QString sender(sender()->name());
  	QString s,n;
  	n.sprintf("%d",currentBT);
  	config->setGroup("Toolbuttons");

	if(sender == "c")
	{
   	s = "btExec"+n;
		config->writeEntry(s,editCommand->text());
		config->sync();
		return;
	}
	if(sender == "p")
	{
   	s = "btParam"+n;
		config->writeEntry(s,editParam->text());
		config->sync();
		return;
	}
	if(sender == "t")
	{
   	s = "btTooltip"+n;
		config->writeEntry(s,editTooltip->text());
		config->sync();
		return;
	}
}

void  dlgEditToolBar::saveParamData(const char *dat)
{
}

void  dlgEditToolBar::saveKCData()
{
}
void  dlgEditToolBar::editFocusInEvent(QFocusEvent *e)
{
}

void dlgEditToolBar::popupSelected(int i)
{
	switch(i)
	{
		case 3:
			editCommand->setText("cmdNETWORK");
			editParam->setText("");
			break;
		case 4:
			editCommand->setText("cmdSWAP_LV");
			editParam->setText("");
			break;
		case 5:
			editCommand->setText("cmdDISCUSAGE");
			editParam->setText("");
			break;
		case 6:
			editCommand->setText("cmdREAD_DIR");
			editParam->setText(i18n("set a Directory"));
			break;
		case 7:
			editCommand->setText("cmdEDITFILE");
			editParam->setText(i18n("set a Parameter"));
			break;
		case 8:
			editCommand->setText("cmdSHOWFILE");
			editParam->setText(i18n("set a Parameter"));
			break;
		case 9:
			editCommand->setText("cmdQUIT");
			editParam->setText(i18n("set a Parameter"));
			break;
	}
	editTooltip->setText(kcPopup->text(i));
}
void dlgEditToolBar::paramSelected(int i)
{
	int cur = editParam->cursorPosition();
	QString s = editParam->text();
	// insert on cursorposition the params
	switch(i)
	{
		case 0:
			s.insert(cur,"^s ");
			editParam->setText(s);
			break;
		case 1:
			s.insert(cur,"^d ");
			editParam->setText(s);
			break;
		case 2:
			s.insert(cur,"^f ");
			editParam->setText(s);
			break;
		case 3:
			s.insert(cur,"^a ");
			editParam->setText(s);
			break;
	}
}