/****************************************************************************
	This file is a part of the KCommander
	(c) 2000, GPL'ed

	(Written by cp <de_cp@yahoo.com>)

******************************************************************************/


#ifndef DLGFFORMAT_H
#define DLGFFORMAT_H

#include <qdialog.h>
#include <qobject.h>
#include <kprocess.h>
#include <qwidget.h>
#include <qpushbutton.h>
#include <klocale.h>
#include <qevent.h>
#include <qcombobox.h>
#include <qcheckbox.h>
#include <qlabel.h>
#include <kmsgbox.h>
#include <kled.h>


class dlgFFormat : public QDialog
{
	Q_OBJECT

public:
	dlgFFormat( QWidget * = 0L, const char * = 0L );

	inline bool selDev() { return fdev->currentItem(); }
	inline bool selFS() { return fsselect->currentItem(); }
	inline bool isLow() { return lowLevel->isChecked(); }

protected:
	virtual void resizeEvent( QResizeEvent * );

private:
	QPushButton *ok, *cancel;
	QComboBox *fdev, *fsselect;
	QCheckBox *lowLevel;
	QLabel *devHelp, *fsHelp;
	KLocale kl;
};

/**
This class manages the floppy format processes.
*/
class formatMan : public QObject
{
	Q_OBJECT

public:
	formatMan();
	~formatMan();

	void invoke();
	/**
	This function shows a "format floppy" dialog and optionally
	invokes the formatting process.
	*/

	void invoke( int, int, bool );

signals:
	void finished(bool);

private:
	void doNext(); //Starts the next process

	KProcess *lowLevel, *mkext2, *mkmsdos;
	int prStep, fFS;

	dlgFFormat *dlgInv;
	QWidget  *visual;
	int         process;
	int         last;
   KLed  *lamps[80];

private slots:
	void prExit( KProcess * );
	void formatOutput (KProcess *proc, char *buffer, int buflen);
};


#endif //DLGFFORMAT_H