/***************************************************************************
                          dlgjoin.cpp  -  description
                             -------------------
    begin                : Sun Nov 7 1999
    copyright            : (C) 1999 by Rene Mrten, Christian Fricke
                           und Torsten Enkelmann
    email                : @-Mail to: delta_x@LinuxCoding.DE
                                      cfricke@LinuxCoding.DE
                                      Torsten@LinuxCoding.DE
****************************************************************************/

#include "dlgjoin.h"

dlgJoin::dlgJoin(QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
	progress = false;	
	connect(QPushButton_1,SIGNAL(clicked()),this,SLOT(cancelPressed()));
	connect(QPushButton_2,SIGNAL(clicked()),this,SLOT(startPressed()));
	
	KCommanderApp *kc = (KCommanderApp *)parent;
	slv = kc->listWithFocus;
	if(slv == kc->linkerListView)
		dlv = kc->rechterListView;
	else
		dlv = kc->linkerListView;
	lbDir->setText(dlv->dirPath);


	QString fName = slv->dirPath + *slv->lastItemClicked->text[0];
	
	QFile f(fName);
	if(f.open(IO_ReadOnly))
	{
		kcsHeader h;
		// Header einlesen
		f.readBlock((char *)&h,sizeof(kcsHeader));
		f.close();
		if(QString(h.header) != "KCS")
		{
			message = 2;		// cant open !
			startTimer(200);
			return;
		}
		QString s;
		s.sprintf("%d Bytes",h.fSize);
		lbSize->setText(s);
		destsize = h.fSize;
	}
	else
	{
		// timer starten zum automatischen Schliessen nach Fehlermeldung
		message = 1;		// cant open !
		startTimer(200);
	}

}

dlgJoin::~dlgJoin(){
}
void dlgJoin::timerEvent(QTimerEvent *e)
{
	killTimers();
	switch(message)
	{
		case 1:
			QMessageBox::information( this, "KCommander", i18n("Cant Open KCSFile"),0 );
			reject();
			break;
		case 2:
			QMessageBox::information( this, "KCommander", i18n("This File Doesnt Splitted By KCommander !!"),0 );
			reject();
			break;
		case 3:
			QMessageBox::information( this, "KCommander", i18n("Cant Open Destination For Write !!"),0 );
			reject();
			break;
	}
}
void dlgJoin::startPressed()
{
	QPushButton_2->setEnabled(false);	// Startbutton ausklinken
	progress = true;							// Progress ist gestartet
	kcsHeader kcs;
	
	// zuerstmal den puren path+namen ohne endung erzeugen
	QString name = slv->dirPath + *slv->lastItemClicked->text[0];
	name = name.left(name.length()-4);	// Endung ist jetzt weg
	QString s = *slv->lastItemClicked->text[0];
	s = s.left(s.length()-4);				// s ist NUR Name OHNE Endung
	QString zielname = dlv->dirPath + s;
	QFile ziel(zielname);
	
	QFile quelle;
	if(ziel.open(IO_WriteOnly))
	{
		// jetzt alle files auslesen und in Ziel schreiben
		
      quelle.setName(name + ".kcs");
      sourcesize = quelle.size();
		char *buffer;
		buffer = (char *)malloc(quelle.size());		// Buffer allokieren
      QString ext;
      int counter = 0;
		
		KProgress_1->setValueRange(0,destsize/sourcesize);

      while(quelle.exists())
      {
	      // Quelle ffnen
	      if(quelle.open(IO_ReadOnly))
				;
			int size;
			// beim ersten File den Header berspringen
			if(!counter)
				size = quelle.readBlock(buffer,sizeof(kcs));
			size = quelle.readBlock(buffer,quelle.size());
			ziel.writeBlock(buffer,size);
   	   quelle.close();

			// jetzt die weiteren files auslesen
			KProgress_1->setValue(++counter);
			if(checkBox->isChecked())
				quelle.remove();
			kapp->processEvents();
			kapp->processEvents();
			kapp->processEvents();
			ext.sprintf(".k%2.2d",counter-1);
			if(!progress)
				ext = "noExt!";
			quelle.setName(name + ext);
		}
		
		ziel.close();
		free(buffer);
		accept();
	}
	else
	{
		message = 3;
		startTimer(200);
	}
}
void dlgJoin::cancelPressed()
{
	if(progress == false) reject();
	progress = false;
}


void  dlgJoin::initDialog(){
  	this->resize(480,160);
	KProgress_1 = new myProgress(0,99,0,myProgress::Horizontal,this,"NoName");
	KProgress_1->setGeometry(20,80,440,20);
	KProgress_1->setMinimumSize(0,0);

  QPushButton_1= new QPushButton(this,"NoName");
  QPushButton_1->setGeometry(360,110,100,30);
  QPushButton_1->setMinimumSize(0,0);
  QPushButton_1->setText(i18n("&Cancel"));

  QPushButton_2= new QPushButton(this,"NoName");
  QPushButton_2->setGeometry(250,110,100,30);
  QPushButton_2->setMinimumSize(0,0);
  QPushButton_2->setText(i18n("&Start"));

  checkBox = new QCheckBox(i18n("Delete Sourcefiles"),this);
  checkBox->setGeometry(20,110,220,20);

  lbDestdir= new QLabel(this,"NoName");
  lbDestdir->setGeometry(20,10,200,30);
  lbDestdir->setMinimumSize(0,0);
  lbDestdir->setText(i18n("Joining to :"));

  lbJoinedsize= new QLabel(this,"NoName");
  lbJoinedsize->setGeometry(20,40,200,30);
  lbJoinedsize->setMinimumSize(0,0);
  lbJoinedsize->setText(i18n("Joined Size :"));

  lbDir= new QLabel(this,"NoName");
  lbDir->setGeometry(220,10,250,30);
  lbDir->setMinimumSize(0,0);

  lbSize= new QLabel(this,"NoName");
  lbSize->setGeometry(220,40,250,30);
  lbSize->setMinimumSize(0,0);

}
