/***************************************************************************
                          dlgkcsinfo.cpp  -  description
                             -------------------
    begin                : Sun Nov 7 1999
    copyright            : (C) 1999 by Rene Mrten, Christian Fricke
                           und Torsten Enkelmann
    email                : @-Mail to: delta_x@LinuxCoding.DE
                                      cfricke@LinuxCoding.DE
                                      Torsten@LinuxCoding.DE
****************************************************************************/

#include "dlgkcsinfo.h"
#include <qfile.h>

dlgKCSinfo::dlgKCSinfo(const char *fName, QWidget *parent, const char *name) : QDialog(parent,name,true){
	initDialog();
	connect(OKButton,SIGNAL(clicked()),this,SLOT(accept()));
	QFile f(fName);
	if(f.open(IO_ReadOnly))
	{
		// Daten auslesen
		kcsHeader h;
		f.readBlock((char *)&h,sizeof(kcsHeader));
		f.close();
		if(QString(h.header) != "KCS")
		{
			message = 2;		// cant open !
			startTimer(200);
			return;
		}
		QString s;
		s.sprintf("%d Bytes",h.fSize);
		lbFilesize->setText(s);
		s = fName;
		s = s.left(s.length()-4);
		while(s.find("/") != -1)
		{
			int p = s.find("/");
			s.remove(0,p+1);
		}
		lbFilename->setText(s);
		s.sprintf("%o",h.permissions);
		lbPermissions->setText(s);
		s.sprintf("%d",h.ownerID);
		lbOwner->setText(s);
		s.sprintf("%d",h.groupID);
		lbGroup->setText(s);
	}
	else
	{
		// timer starten zum automatischen Schliessen nach Fehlermeldung
		message = 1;		// cant open !
		startTimer(200);
	}
}

dlgKCSinfo::~dlgKCSinfo(){
}

void dlgKCSinfo::timerEvent(QTimerEvent *e)
{
	killTimers();
	switch(message)
	{
		case 1:
			QMessageBox::information( this, "KCommander", i18n("Cant Open KCSFile"),0 );
			reject();
			break;
		case 2:
			QMessageBox::information( this, "KCommander", i18n("This File Doesnt Splitted By KCommander !!"),0 );
			reject();
			break;
	}
}


void  dlgKCSinfo::initDialog(){
  this->resize(480,230);
  this->setMinimumSize(0,0);
  QLabel_1= new QLabel(this,"NoName");
  QLabel_1->setGeometry(20,30,120,20);
  QLabel_1->setMinimumSize(0,0);
  QLabel_1->setText(i18n("Filename :"));

  QLabel_2= new QLabel(this,"NoName");
  QLabel_2->setGeometry(20,60,120,20);
  QLabel_2->setMinimumSize(0,0);
  QLabel_2->setText(i18n("Joined Filesize :"));

  QLabel_3= new QLabel(this,"NoName");
  QLabel_3->setGeometry(20,90,120,20);
  QLabel_3->setMinimumSize(0,0);
  QLabel_3->setText(i18n("Permissions :"));

  QLabel_4= new QLabel(this,"NoName");
  QLabel_4->setGeometry(20,120,120,20);
  QLabel_4->setMinimumSize(0,0);
  QLabel_4->setText(i18n("Owner ID:"));

  QLabel_5= new QLabel(this,"NoName");
  QLabel_5->setGeometry(20,150,120,20);
  QLabel_5->setMinimumSize(0,0);
  QLabel_5->setText(i18n("Group ID:"));

  lbFilename= new QLabel(this,"NoName");
  lbFilename->setGeometry(140,30,320,20);
  lbFilename->setMinimumSize(0,0);
  lbFilename->setFont(QFont("helvetica", 12, 50));

  lbFilesize= new QLabel(this,"NoName");
  lbFilesize->setGeometry(140,60,320,20);
  lbFilesize->setMinimumSize(0,0);
  lbFilesize->setFont(QFont("helvetica", 12, 50));

  lbPermissions= new QLabel(this,"NoName");
  lbPermissions->setGeometry(140,90,320,20);
  lbPermissions->setMinimumSize(0,0);
  lbPermissions->setFont(QFont("helvetica", 12, 50));

  lbOwner= new QLabel(this,"NoName");
  lbOwner->setGeometry(140,120,320,20);
  lbOwner->setMinimumSize(0,0);
  lbOwner->setFont(QFont("helvetica", 12, 50));

  lbGroup= new QLabel(this,"NoName");
  lbGroup->setGeometry(140,150,320,20);
  lbGroup->setMinimumSize(0,0);
  lbGroup->setFont(QFont("helvetica", 12, 50));

  OKButton= new QPushButton(this,"NoName");
  OKButton->setGeometry(360,180,100,30);
  OKButton->setMinimumSize(0,0);
  OKButton->setText(i18n("&OK"));

}
