#include "hexview.h"
#include "dlgshow.h"
#include <kprocess.h>
			
void showWidget :: init()
		{
      spopup = new QPopupMenu;
      id = spopup->insertItem(i18n("&F3 Quit..."),this,SLOT(menuPressed()), 0,10010);
      id = spopup->insertItem(i18n("&Search..."),this,SLOT(menuPressed()), 0,10020);
      id = spopup->insertItem(i18n("&F4 Hex-View"),this,SLOT(menuPressed()), 0,10021);
      id = spopup->insertItem(i18n("&HTML-View"),this,SLOT(menuPressed()), 0,10030);
      spopup->setItemEnabled(id,false);
      id = spopup->insertItem(i18n("&Picture-View"),this,SLOT(menuPressed()), 0,10040);
      spopup->setItemEnabled(id,false);
 			connect(spopup,SIGNAL(activated ( int )),this,SLOT(menuActivated ( int)));

      ked = new KEdit(kapp,this,"Show");
    	
    	struct listItem *s = Source->Liste;  // also hier erstemal Zeiger auf Sourceliste holen
	    while(s != 0)
	    {
    	 if (s->hasFocus) break;
        else s = s->next;
      }
 			    sou = SourcePath + *s->text[0];	
		      QFileInfo gr(sou);
		      if(gr.extension()=="htm"||gr.extension()=="html") // HTML Ansicht nur fr diese Files
		      		spopup->setItemEnabled(10030,true);
		      if(gr.extension()=="jpg"||gr.extension()=="gif"||gr.extension()=="xpm"||gr.extension()=="bmp"||gr.extension()=="png"
		      		||gr.extension()=="ppm"||gr.extension()=="pbm"||gr.extension()=="pgm") // Picture Ansicht nur fr diese Files
		      		spopup->setItemEnabled(10040,true);
		      if(gr.extension()=="jpg"||gr.extension()=="png") jpeg_image = true;
		      if(!gr.isDir())
				{
        	setCaption(i18n("KCommander-Show - CTRL+M for Menu! ")+sou);
          ked->loadFile(sou,2);
			 		ked->installRBPopup(spopup);	
					s = 0;
				}
				else
        {
					weg();
        }
      hexWindow = new Hexview(sou,this);
      hexWindow->hide();
      connect(hexWindow,SIGNAL(sigClosed()),SLOT(closed()));
      ked->setFocusPolicy(QWidget::StrongFocus);
		};

// Kostruktor fr das ganze Ding
showWidget::showWidget(listView *S,const char *SP,QWidget *parent, const char *name ): QWidget( parent, name )
		{
		  Source = S;
		  SourcePath = SP;
		  jpeg_image = false;
			init();
		}
void showWidget::menuPressed()
{
}

void showWidget::menuActivated(int itemId)
{
	switch (itemId)
		{
			case 10020:
				ked->Search();
				break;
			case 10010:
				weg();
				break;
			case 10030:
				htmlView();
				break;
			case 10021:
				this->resize(hexWindow->width(),hexWindow->height());
	      ked->setFocusPolicy(QWidget::NoFocus);
	      hexWindow->setFocusPolicy(QWidget::TabFocus);
	 			hexWindow->setFocus();
	 			hexWindow->show();
				break;
			case 10040:
				picView();
				break;
    }
      ked->setFocusPolicy(QWidget::StrongFocus);
}
				
void showWidget::resizeEvent(QResizeEvent *t)
{
  hexWindow->setGeometry(0,0,hexWindow->width(),hexWindow->height());
	ked->resize(width(),height());
}

showWidget::~showWidget()
{
	delete ked;
	delete spopup;
};

void showWidget::weg()
{
	close();
}

void showWidget::keyPressEvent(QKeyEvent *e)
{
 int key = e->key();
 int state = e->state();
	
	QString s;
	s.sprintf("%d",key);
//	debug(s);
 switch (key)
 	{
 		case 4096:
 			weg();
 			break;
 		case 4146:
 			weg();
 			break;
 		case 4147:
			this->resize(hexWindow->width(),hexWindow->height());
      ked->setFocusPolicy(QWidget::NoFocus);
      hexWindow->setFocusPolicy(QWidget::TabFocus);
 			hexWindow->setFocus();
 			hexWindow->show();
 			break;
 		case 77:
 			if(state == 16)
 				{
					spopup->exec(this->mapToGlobal(QPoint(0,0)));
// 					spopup->setGeometry(x()+10,y()+30,100,150);
// 					spopup->show();}
 		}
 		break;
 	}
      ked->setFocusPolicy(QWidget::StrongFocus);
}

void showWidget::htmlView()
{
  sou = tools::convertPfad(sou);
	KShellProcess proc("bash");
	proc <<"kfmclient";
	proc <<"openURL";
	proc <<sou;
	proc.start(KProcess::Block,KProcess::All);
	return;
}

void showWidget::picView()
{
	if(jpeg_image)
	{
		KShellProcess proc("bash");
		proc <<"kview";
		proc <<sou;
		proc.start(KProcess::Block,KProcess::All);
	}
	else
	{
		neu = new ownShow(sou);
		neu->show();
	}
	return;
}

void showWidget::mousePressEvent(QMouseEvent* e)
{
//	debug("mouseevent");
	if(e->button()== RightButton ) spopup->popup(mapToGlobal(e->pos()));
}

//******************************************************************************************************************
//******************************************************************************************************************

void  ownShow::initDialog(){
  this->setMinimumSize(10,10);
	this->setBackgroundColor(white);
	this->setCaption(i18n("Picture-View"));
}

ownShow::ownShow(QString file,QWidget *parent, const char *name) : QWidget(parent,name){
	filename = file;
	initDialog();
	
	if ( image.load(filename));
	else debug("not implemented yet !!!");              // load and draw image
	resize(image.size());
}

ownShow::~ownShow(){
}

void ownShow::paintEvent( QPaintEvent *e)
{
	QPainter paint(this);
	paint.drawImage(1,1,image);	
}
//*******************************************************************************************************************
//*******************************************************************************************************************


void showWidget::closed()
{
   close();
}

