/***************************************************************************
                          dlgsplit.cpp  -  description
                             -------------------
    begin                : Tue Oct 26 1999
    copyright            : (C) 1999 by Rene Mrten, Christian Fricke
                           und Torsten Enkelmann
    email                : @-Mail to: delta_x@LinuxCoding.DE
                                      cfricke@LinuxCoding.DE
                                      Torsten@LinuxCoding.DE
****************************************************************************/

#include "dlgsplit.h"

dlgSplit::dlgSplit(QWidget *parent, const char *name) : QDialog(parent,name,true){
	
	initDialog();
	process = false;
	KCommanderApp *p = (KCommanderApp *)parent;
	QString path;
	QString filename;
	if(p->listWithFocus == p->linkerListView)
	{
		path = p->rechterListView->dirPath;
	}
	else
	{
		path = p->linkerListView->dirPath;
   }
	DestPath = path;
	QLineEdit_3->setText(path);
	path = p->listWithFocus->dirPath;
	SourcePath = path;
	filename = *p->listWithFocus->lastItemClicked->text[0];
	QLineEdit_4->setText(filename);
	QString filepathname = path + filename;
	QFileInfo f(filepathname);
	double size = f.size();
	QString s;
	s.sprintf("%.2f MB",size/1024000);
	QLineEdit_1->setText(s);
	QLineEdit_2->setText("0.72 MB");
 	QLineEdit_2->hide();
 	QLabel_6->setText("0.72 MB");
	
	connect(QSlider_1,SIGNAL(valueChanged(int)),this,SLOT(sizeChanged(int)));
	connect(QLineEdit_2,SIGNAL( textChanged ( const char * )),this,SLOT(mbChanged(const char * )));
	connect(QLineEdit_3,SIGNAL( textChanged ( const char * )),this,SLOT(dirChanged(const char * )));
	connect(CommandButton0,SIGNAL(clicked()),this,SLOT(bt0Clicked()));
	connect(CommandButton1,SIGNAL(clicked()),this,SLOT(bt1Clicked()));
}

dlgSplit::~dlgSplit(){
}

void dlgSplit::sizeChanged(int i)
{
	QString s;
	switch (i)
	{
		case 0:	s = "0.72 MB";
					QLineEdit_2->hide();
					break;
		case 1:	s = "1.44 MB";
					QLineEdit_2->hide();
					break;
		case 2:	s = "2.88 MB";
					QLineEdit_2->hide();
					break;
		case 3:	s = "0.00 MB";
					QLineEdit_2->setText(s);
					QLineEdit_2->show();
					QLineEdit_2->setSelection(0,4);
					QLineEdit_2->setCursorPosition(0);
					QLineEdit_2->setFocus();
					return;
					break;
	}
 	QLabel_6->setText(s);
 	QLineEdit_2->setText(s);
}

void dlgSplit::mbChanged(const char *t)
{
	QString s(t);
	s = s.upper();
	int p = QLineEdit_2->cursorPosition();
	QLineEdit_2->setText(s);
	QLineEdit_2->setCursorPosition(p);
	
}
void dlgSplit::dirChanged(const char *t)
{
	QDir d(QLineEdit_3->text());
	if(d.exists())
		CommandButton0->setEnabled(true);
	else
		CommandButton0->setEnabled(false);
}
void dlgSplit::bt0Clicked()
{
	QString s(QLineEdit_3->text());
	if(s.right(1) != "/")
	{
		s += "/";
		QLineEdit_3->setText(s);
	}
  	float f = atof(QLineEdit_2->text());
  	int destSize = (int)(f *1024000);
  	
	if(!destSize)
	{
		// 0 Bytes Lnge ?! Fehlermeldung und zurck
		QMessageBox::information( this, "KCommander", i18n("Filesize must be larger than 0 Bytes !!"),0 );
		return; // !!!
	}
	
	char *buffer;
	buffer = (char *)malloc(destSize);
	if(!buffer)
	{
		// kein Speicher !!!
		QMessageBox::information( this, "KCommander", i18n("Destsize to big ! Cant Allocate Memory !!"),0 );
		return; // !!!
	}
	// alles unantastbar machen
	QLineEdit_3->setEnabled(false);		// Eingabe fr DestDir
	QSlider_1->  setEnabled(false);		// Slider
	QLineEdit_2->setEnabled(false);		// Eingabe fr Size
  	QPushButton_1->setEnabled(false);	// BrowseButton
  	CommandButton0->setEnabled(false);	// START
	
	// und jetzt gehts los !
	process = true;
	QFile sourcefile(SourcePath + QLineEdit_4->text());
	if(sourcefile.size() < (uint)destSize)
	{
		// Speicher wieder freigeben
		free(buffer);
		QMessageBox::information( this, "KCommander", i18n("Destsize Larger Than Sourcefile !!"),0 );
		reject();
		return;
	}
	QString destName;
	int counter = 0;
	if(sourcefile.open( IO_ReadOnly ))
	{
	  	int size = sourcefile.size();
	  	KProgress_1->setValueRange(0,size / (f*1024000));	// SourceSize / Diskgroesse

/*
struct kcsHeader{
		char		header[4];
		uint		fSize;
		int		permissions;
		int		ownerID;
		int		groupID;
};
*/
		QFileInfo fi(SourcePath + QLineEdit_4->text());
		kcsHeader header;
		strcpy(header.header,"KCS");
		header.fSize = sourcefile.size();
      header.permissions = optionen::getFilePermission(SourcePath + QLineEdit_4->text());
      header.groupID = fi.groupId();
      header.ownerID = fi.ownerId();
		
		// die anderen beiden IDs kommen spter
		
		
		while(process)
		{
			destName = DestPath + QLineEdit_4->text();
			if(!counter)
				destName += ".kcs";	// (K)(C)ommander-(S)plitfile Kennung
			else
			{
				QString ext;
				ext.sprintf(".k%2.2d",counter-1);
				destName += ext;
			}
			// Ziel ffnen
			QFile destfile(destName);
			
			if(!destfile.open(IO_WriteOnly))
			{
				QMessageBox::information( this, "KCommander", i18n("Can not open Destinationfile !!"),0 );
				process = false;
				break;
			}
			else
			{
				// hier wird kopiert !!
				if(!counter)
				{
					// beim ersten File den Header mit rein !
					destfile.writeBlock((const char *)&header,sizeof(header));
					int bytes = sourcefile.readBlock(buffer,destSize - sizeof(header));
					destfile.writeBlock(buffer,bytes);
				}
				else
				{
					int bytes = sourcefile.readBlock(buffer,destSize);
					destfile.writeBlock(buffer,bytes);
				}
				destfile.close();
				if(sourcefile.atEnd())
					process = false;		// Wenn Source ausgelesen ist, dann Schluss
			}
			counter ++;
			KProgress_1->setValue(counter);
			kapp->processEvents();
			kapp->processEvents();
			kapp->processEvents();
		}
		sourcefile.close();
	}
	else
		QMessageBox::information( this, "KCommander", i18n("Can not open Sourcefile !!"),0 );
	
	free(buffer);
	accept();

}
void dlgSplit::bt1Clicked()
{
	if(!process) reject();
	process = false;
}

void  dlgSplit::initDialog(){
  resize(570,370);
  setMinimumSize(570,370);
	KProgress_1 = new myProgress(0,99,0,myProgress::Horizontal,this,"NoName");
  KProgress_1->setGeometry(20,260,530,20);

  QLabel_1= new QLabel(this,"NoName");
  QLabel_1->setGeometry(20,100,250,30);
  QLabel_1->setFont(QFont("helvetica", 14, 50));
  QLabel_1->setText(i18n("Size of Sourcefile:"));

  QLineEdit_1= new QLabel(this,"size0");
  QLineEdit_1->setGeometry(280,100,270,30);
  QLineEdit_1->setFont(QFont("helvetica", 14, 50));

  QLabel_2= new QLabel(this,"NoName");
  QLabel_2->setGeometry(20,140,250,30);
  QLabel_2->setFont(QFont("helvetica", 14, 50));
  QLabel_2->setText(i18n("Size of the Destination Files:"));

  QLabel_6= new QLabel(this,"NoName");
  QLabel_6->setGeometry(280,140,270,30);
  QLabel_6->setFont(QFont("helvetica", 14, 50));

  QLineEdit_2= new QLineEdit(this,"size1");
  QLineEdit_2->setGeometry(280,140,270,30);
  QLineEdit_2->setFont(QFont("helvetica", 14, 50));


  QSlider_1= new QSlider(this,"NoName");
  QSlider_1->setGeometry(280,180,270,20);
  QSlider_1->setRange(0,3);
  QSlider_1->setOrientation(QSlider::Horizontal);

  QLabel_3= new QLabel(this,"NoName");
  QLabel_3->setGeometry(20,210,250,30);
  QLabel_3->setFont(QFont("helvetica", 14, 50));
  QLabel_3->setText(i18n("Destination Directory:"));

  QLineEdit_3= new QLineEdit(this,"destDir");
  QLineEdit_3->setGeometry(280,210,230,30);

  QPushButton_1= new QPushButton(this,"NoName");
  QPushButton_1->setGeometry(520,220,30,20);
  QPushButton_1->setText(i18n("..."));

  CommandButton0= new QPushButton(this,"command0");
  CommandButton0->setGeometry(180,330,100,30);
  CommandButton0->setFont(QFont("helvetica", 14, 75,true));
  CommandButton0->setText(i18n("&Start"));

  CommandButton1= new QPushButton(this,"command1");
  CommandButton1->setGeometry(290,330,100,30);
  CommandButton1->setFont(QFont("helvetica", 14, 75,true));
  CommandButton1->setText(i18n("&Cancel"));

  QLabel_4= new QLabel(this,"NoName");
  QLabel_4->setGeometry(20,60,250,30);
  QLabel_4->setFont(QFont("helvetica", 14, 50));
  QLabel_4->setText(i18n("Sourcefile:"));

  QLineEdit_4= new QLabel(this,"fileName");
  QLineEdit_4->setGeometry(280,60,270,30);
  QLineEdit_4->setFont(QFont("helvetica", 14, 50));

  QLabel_5= new QLabel(this,"NoName");
  QLabel_5->setGeometry(20,10,530,30);
  QLabel_5->setFont(QFont("helvetica", 14, 75,true));
  QLabel_5->setText(i18n("Splitting Files"));
  QLabel_5->setAlignment(AlignHCenter);

}
