#include "hexview.h"
#include <stdlib.h>
#include <kfiledialog.h>

Hexview::Hexview(QString file,QWidget *parent, const char *name) : QWidget(parent,name){
	fileName = file;
  paint = new QPainter();
	SIZE = 304;  // wird im ResizeEvent neu berechnet !!!
	
	buffer = new unsigned char[1500];
	offset[0] = 0;
	offset[1] = 0;
	readed = 0;
	oldstyle = false;
	cursorPosX = 0;
	cursorPosY = 0;
	oldPosX = 0;
	oldPosY = 0;
	
	initDialog();
	openFile();
	readed = viewFileForward();
	closeFile();
	makeStringList();
  QPopupMenu_1->setItemEnabled(10110,true);
  QPopupMenu_1->setItemEnabled(10120,true);
  QPopupMenu_1->setItemEnabled(10130,true);
}

Hexview::~Hexview()
{
	delete[] buffer;
	delete KSeparator_14;
	delete QPushButton_3;
	delete QPushButton_2;
   delete pixUp;
   delete pixDown;
}

bool Hexview::openFile()
{
	file.open(fileName,ios::in|ios::out|ios::binary);
	if(file) return true;
	else return false;
}

bool Hexview::closeFile()
{
	file.close();
	return true;
}

int Hexview::viewFileForward()
{
	offset[0] = offset[1];
	file.seekp(offset[0]);
	file.read(buffer,SIZE);
	offset[1] = file.tellg();
	
	if(offset[1]-offset[0] < SIZE) // Damit er keinen Unsinn macht am Fileende !!!!!
		QPushButton_3->hide();
	else QPushButton_3->show();
	
	if(offset[0]==0)              // Und wenn ganz oben dann mach diesen aus !!!
		QPushButton_2->hide();
	else QPushButton_2->show();
	
	return (offset[1]-offset[0]);
}

int Hexview::viewFileBack()
{
	if(offset[0]-2*SIZE >= 0)
	{
		offset[1] = offset[0]-SIZE;
		offset[0] = offset[0]-2*SIZE;
		viewFileForward();
	}
	else
	{
		offset[0] = 0;
		offset[1] = 0;
		viewFileForward();
	};
	return (offset[1]-offset[0]);
}

bool Hexview::makeStringList()
{
	liste.clear();
	liste1.clear();
  QString a,s,t;
	int i,j = 0;
	for(i = 0;i<SIZE/16;i++)
	{
		s.sprintf("");
		t.sprintf("");
	  s.sprintf(s+"%08x",offset[0]+i*16);  //Zeilen-nummer
	  s.sprintf(s+"%c",' ');
	  s.sprintf(s+"%c",' ');
		for(j = 0;j<16;j++) // 16 Zeichen breit
		{
	  	if(j+(i*16) < readed) //damit kein Speichermll angezeigt wird				
		  {
			  s.sprintf(s+"%02x ",buffer[j+(i*16)]);
		
		 		a.sprintf("%d",buffer[j+(i*16)]);
				int b = atoi(a);
				if(b > 32)         // gucken ob ein unsichtbares Zeichen da ist !!!
					t.sprintf(t+"%c",buffer[j+(i*16)]);
				else
					t += ".";	
			  t += " ";
		  }
 	  	else s += "   ";
		}		
	  if(i*j > readed) break;
		liste.append(s);
		liste1.append(t);
	}
	return true;
}

void Hexview::paintEvent( QPaintEvent *e)
{
	paint->begin(this);
	QFont p("courier");
	p.setPointSize(12);
	paint->setFont(p);
	if(oldstyle)paint->setPen(green);
	liste.first();
	liste1.first();
	for(int i=0; i< (int)readed/16+1;i++)
	{
		paint->drawText(0,i*20+20,liste.current());
		paint->drawText(415,i*20+20,liste1.current());
		liste.next();
		liste1.next();
	}
//////////	if(fileName.isEmpty()) this->close();
	drawCursor();
	paint->end();
}

void Hexview::resizeEvent(QResizeEvent *e)
{
	offset[1] = offset[0];
	SIZE = ((int)this->height()/20)*16;
	QPushButton_3->move(640,this->height()-60);
	KSeparator_14->resize(10,this->height()-15);
	page_down();
}

void Hexview::page_down()
{
	openFile();
	readed = viewFileForward();
	closeFile();
	makeStringList();
	update();
	return;
}

void Hexview::page_up()
{
	openFile();
	readed = viewFileBack();
	closeFile();
	makeStringList();
	update();
	return;
}

void Hexview::menuActivated(int itemId)
{
	switch (itemId)
		{
			case 10110:
				emit (sigClosed());
				break;
			case 10120:
					if(oldstyle)oldstyle = false;
					else oldstyle = true;
					if(backgroundColor() == black)this->setBackgroundColor(white);
					else setBackgroundColor(black);
					if(KSeparator_14->backgroundColor()== black) KSeparator_14->setBackgroundColor(white);
					else KSeparator_14->setBackgroundColor(black);
				break;
			case 10130:
				hide();
      	setFocusPolicy(QWidget::NoFocus);
//				close();
				break;
    }
}
void Hexview::menuPressed()
{
}
void Hexview::mousePressEvent(QMouseEvent* e)
{
	if(e->button()== RightButton ) QPopupMenu_1->popup(mapToGlobal(e->pos()));
}

void Hexview::keyPressEvent(QKeyEvent *e)
{
 int state = e->state();
	oldPosX = cursorPosX;
	oldPosY = cursorPosY;
	switch(e->key())
	{
 		case 4096:
 			emit (sigClosed());
 			break;
 		case 4146:
 			emit (sigClosed());
 			break;
		case 0x1015:
			cursorPosY += 20;
			break;
		case 0x1013:
			cursorPosY -= 20;
			break;
		case 0x1012:
			cursorPosX -= 21;
			break;
		case 0x1014:
			cursorPosX += 21;
			break;
		case 4147:
			close();
			break;
 		case 77:
 			if(state == 16)
 				{
					QPopupMenu_1->exec(this->mapToGlobal(QPoint(0,0)));
		 		}
			 		break;
	}
//  CursorPosition!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	if(cursorPosX < 0)     // X-position not visible
	{
		cursorPosY -= 20;
		cursorPosX =15*21;
	}
	if(cursorPosX	> 21*15)
	{
		cursorPosY += 20;
		cursorPosX =0;
	}
	if(cursorPosY	< 0)     // Y-position not visible
	{
		if(QPushButton_2->isVisible())  // is it the beginning ??
		{
			page_up();
			cursorPosY = 20*(SIZE/16-1);
		}
		// if it is the beginning of file cursor dont move
		else
		{
			cursorPosY = 0;
			cursorPosX = 0;
		}
	}
	if(cursorPosY	>= 20*(readed/16))
	{
		if(QPushButton_3->isVisible())  // is it the end ??
		{
			page_down();
			cursorPosY = 0;
		}
		// if it is the end of file cursor dont move
		else
		{
			//for X-moving at the last line
			if(cursorPosX > 21*(readed-1-(readed/16)*16))cursorPosX = 21*(readed-1-(readed/16)*16);
			//if it's real greater goto the real END
			if(cursorPosY	> 20*(readed/16))cursorPosX = 21*(readed-1-(readed/16)*16);
			cursorPosY = 20*(readed/16);
			// here it comes an error if filesize = 0 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!1
		}
	}
	paint->begin(this);
		drawCursor();
	paint->end();
}

void Hexview::drawCursor()
{
  paint->setPen(backgroundColor());
  paint->drawRect(oldPosX+67,oldPosY+5,20,20);
  paint->drawRect(((oldPosX*2)/3)+413,oldPosY+5,12,20);
  paint->setPen(red);
  paint->drawRect(cursorPosX+67,cursorPosY+5,20,20);
  paint->drawRect(((cursorPosX*2)/3)+413,cursorPosY+5,12,20);
}

