#include <iostream.h>

#include "Iconfiles/mini-kcommander.xpm"
#include "resource.h"

// include files for QT
#include <qdir.h>
#include <qstrlist.h>
#include <qprinter.h>
#include <qpainter.h>

// include files for KDE
#include <kiconloader.h>
#include <kmsgbox.h>
#include <kfiledialog.h>
#include <klocale.h>
#include <kaccel.h>
#include <qaccel.h>

// application specific includes
#include "kcommander.h"
#include "mainslots.h"
#include "aboutwindow.h"
#include "readdir.h"

#include "Iconfiles/hd.xpm"
#include "Iconfiles/folder2.xpm"
#include "Iconfiles/file.xpm"
#include "Iconfiles/filelink.xpm"
#include "Iconfiles/folderLink.xpm"
#include "Iconfiles/archive.ext"
#include "Iconfiles/MSexe.ext"
#include "Iconfiles/network1.xpm"
#include "Iconfiles/network2.xpm"
#include "Iconfiles/network3.xpm"
#include "Iconfiles/up.xpm"
#include "kcs.ext"

KCommanderApp::KCommanderApp()
{
	for(int i=0;i<99;i++)
	   buttonBar[i] = 0;
	
	foldericon = 		new QPixmap((const char **)folder2);
	folderlinkicon = 	new QPixmap((const char **)folderLink);
	fileicon = 			new QPixmap((const char **)file);
	linkicon = 			new QPixmap((const char **)filelink);
	upicon   = 			new QPixmap((const char **)up);	
	kcsicon   = 		new QPixmap((const char **)kcs);	
	archiveicon =     new QPixmap((const char **)archive);
	msexeicon =       new QPixmap((const char **)msexe);
	network1Icon =    new QPixmap((const char **)network1);
	network2Icon =    new QPixmap((const char **)network2);
	network3Icon =    new QPixmap((const char **)network3);
	
	driveSpace = 0;
	SMB_MOUNT_SHARE = false;
	config=kapp->getConfig();
	init();
	toolbar = 0;
	updateToolbar();
	// TEST
	startTimer(500);
	dirListBox = 0;
}

KCommanderApp::~KCommanderApp()
{
	delete linkerListView;
 	delete rechterListView;
	for(int i=0;i<7;i++)
		delete buttonLeiste[i];
	delete cg1;
	delete cg2;
	if(dirListBox)
		delete dirListBox;
	if(driveSpace)
	   delete driveSpace;
	// Icons deleten
	delete foldericon;
	delete folderlinkicon;
	delete fileicon;
	delete linkicon;
	delete upicon;
   delete kcsicon;
   delete archiveicon;
   delete msexeicon;
	delete network1Icon;
	delete network2Icon;
	delete network3Icon;
}

void KCommanderApp::initKeyAccel()
{
	key_accel = new KAccel( this );
  key_accel->readSettings();	
}

void KCommanderApp::enableCommand(int id_)
{
  ///////////////////////////////////////////////////////////////////
  // enable menu and toolbar functions by their ID's
  menuBar()->setItemEnabled(id_,true);
}

void KCommanderApp::disableCommand(int id_)
{
  ///////////////////////////////////////////////////////////////////
  // disable menu and toolbar functions by their ID's
  menuBar()->setItemEnabled(id_,false);
}




void KCommanderApp::saveOptions()										// Optionen speichern
{	
	QString s;
	KConfig *config;
	config = kapp->getConfig();
	
	config->setGroup("KC_GENERAL");
	config->writeEntry("FensterX",x());
	config->writeEntry("FensterY",y());
	config->writeEntry("FensterB",width());
	config->writeEntry("FensterH",height());
	for(int i=0;(i<commandBox->count()) && (i<30);i++)
	{
		s.sprintf("Kommando%d",i);
		config->writeEntry(s,commandBox->text(i));
	}
	
   config->setGroup("LISTVIEWENTRYS");
   config->writeEntry("BackgroundColor",linkerListView->backgroundColor.rgb());
   config->writeEntry("SelBackgroundColor",linkerListView->selBackgroundColor.rgb());
   config->writeEntry("forgroundColor",linkerListView->forgroundColor.rgb());
   config->writeEntry("selForgroundColor",linkerListView->selForgroundColor.rgb());
   config->writeEntry("LinkerPath",leftDirPath);
   config->writeEntry("rechterPath",rightDirPath);
   config->writeEntry("cursorRand",linkerListView->cursorRand.rgb());
   config->writeEntry("cursorFilled",linkerListView->cursorFilled);
   config->writeEntry("cursorColor",linkerListView->cursorColor.rgb());
   config->writeEntry("cursorColorSelected",linkerListView->cursorColorSelected.rgb());
   config->writeEntry("cursorTextColor",linkerListView->cursorTextColor.rgb());
   config->writeEntry("cursorTextColorSelected",linkerListView->cursorTextColorSelected.rgb());

// Save Colums
//	for(int i=0; i<linkerListView->colums ;i++)
	for(int i=0; i<4 ;i++)
	{
		s.sprintf("LeftColum%d",i);
		config->writeEntry(s,linkerListView->columWidth[i]);
	}
//	for(int i=0; i<rechterListView->colums ;i++)
	for(int i=0; i<4 ;i++)
	{
		s.sprintf("rightColum%d",i);
		config->writeEntry(s,rechterListView->columWidth[i]);
	}
//*********************************************************
  	config->setGroup("dirFilter");
		
  	config->writeEntry("leftFilter",linkerListView->dirFilter);
  	config->writeEntry("rightFilter",rechterListView->dirFilter);
//*********************************************************
  config->sync();
	
}

void KCommanderApp::readOptions()                    // Optionen laden
{
	KConfig *config;
	QString s;
//*********************************************************
	config = kapp->getConfig();
  	config->setGroup("dirFilter");
  	int l = config->readNumEntry("leftFilter",903);    // default = ALL
  	int r = config->readNumEntry("rightFilter",903);   // default = ALL
  	linkerListView->dirFilter = l;
  	rechterListView->dirFilter = r;
//*********************************************************
	int fx,fy,fb,fh;
	config->setGroup("KC_GENERAL");
	// Version des KC, der die Optionen geschrieben hat
	s = config->readEntry("Version:","0");

	// Fenstereinstellungen
	fx = config->readNumEntry("FensterX",x());
	fy = config->readNumEntry("FensterY",y());
	fb = config->readNumEntry("FensterB",width());
	fh = config->readNumEntry("FensterH",height());
  // mainwindow Koordinaten setzen
  setGeometry(fx,fy,fb,fh);
	
	commandBox->clear();
	for(int i=0;i<30;i++)
	{
      s.sprintf("Kommando%d",i);
      s = config->readEntry(s,"");
      if(s == "") break;
      commandBox->insertItem(s);
	}
	commandBox->setEditText("");
	
//****************************************************************************	
	config->setGroup("LISTVIEWENTRYS");
	QRgb farbe;
	
	farbe = config->readNumEntry("BackgroundColor",0xffffff);
	linkerListView->backgroundColor = QColor(farbe);
	rechterListView->backgroundColor = QColor(farbe);
	
	farbe = config->readNumEntry("SelBackgroundColor",0x0000cc);
	linkerListView->selBackgroundColor = QColor(farbe);
	rechterListView->selBackgroundColor = QColor(farbe);
	
	farbe = config->readNumEntry("forgroundColor",0x000000);
	linkerListView->forgroundColor = QColor(farbe);
	rechterListView->forgroundColor = QColor(farbe);
	
	farbe = config->readNumEntry("selForgroundColor",0xff0000);
	linkerListView->selForgroundColor = QColor(farbe);
	rechterListView->selForgroundColor = QColor(farbe);
	
	farbe = config->readNumEntry("cursorRand",0x0000ff);
	linkerListView->cursorRand = QColor(farbe);
	rechterListView->cursorRand = QColor(farbe);
  
	farbe = config->readNumEntry("cursorColor",0xff00ff);
	linkerListView->cursorColor = QColor(farbe);
	rechterListView->cursorColor = QColor(farbe);

	bool flag = config->readBoolEntry("cursorFilled",false);
	linkerListView->cursorFilled = flag;
	rechterListView->cursorFilled = flag;
	  
	farbe = config->readNumEntry("cursorColorSelected",0xcccccc);
	linkerListView->cursorColorSelected = QColor(farbe);
	rechterListView->cursorColorSelected = QColor(farbe);
  
	farbe = config->readNumEntry("cursorTextColor",0xff00ff);
	linkerListView->cursorTextColor = QColor(farbe);
	rechterListView->cursorTextColor = QColor(farbe);
  
	farbe = config->readNumEntry("cursorTextColorSelected",0xcccccc);
	linkerListView->cursorTextColorSelected = QColor(farbe);
	rechterListView->cursorTextColorSelected = QColor(farbe);
  
  leftDirPath = config->readEntry("LinkerPath","/");
  if(leftDirPath == "")
      leftDirPath = "/";
  rightDirPath = config->readEntry("rechterPath","/etc");
  if(rightDirPath == "")
      rightDirPath = "/etc";
		
	
	linkerListView->refreshColums(0);
	rechterListView->refreshColums(0);
	readDir(leftDirPath,linkerListView);
	readDir(rightDirPath,rechterListView);
// Spaltenbreiten laden
	int n;
//	for(int i=0; i<linkerListView->colums ;i++)
	for(int i=0; i<4 ;i++)
	{
		s.sprintf("LeftColum%d",i);
		if(config->hasKey(s))
				n = config->readNumEntry(s,linkerListView->columWidth[i]);
		else
				if(i > 0)
					n = linkerListView->columWidth[i-1]+150;
				else
					n = (i+1)*150;
		if(n > 600)
			n = 600;
		linkerListView->columWidth[i] = n;
	}
//	for(int i=0; i<rechterListView->colums ;i++)
	for(int i=0; i<4 ;i++)
	{
		s.sprintf("RightColum%d",i);
		if(config->hasKey(s))
				n = config->readNumEntry(s,rechterListView->columWidth[i]);
		else
				if(i > 0)
					n = rechterListView->columWidth[i-1]+150;
				else
					n = (i+1)*150;
		if(n > 600)
			n = 600;
		rechterListView->columWidth[i] = n;
	}
	
	for(int i=0;i<linkerListView->colums-1;i++)
	{
		if(linkerListView->columWidth[i] >= linkerListView->columWidth[i+1])
		{
			linkerListView->columWidth[i+1] = linkerListView->columWidth[i]+150;
		}
	}
	for(int i=0;i<rechterListView->colums-1;i++)
	{
		if(rechterListView->columWidth[i] >= rechterListView->columWidth[i+1])
		{
			rechterListView->columWidth[i+1] = rechterListView->columWidth[i]+150;
		}
	}

	itemSelected();
	config->setGroup("Packer");
	packMethode = config->readEntry("Methode","gzip");
}

void KCommanderApp::updateToolbar()
{
	KConfig *config;
	config = kapp->getConfig();
	config->setGroup("Bars");
//destroy the buttonbar-struct

   int i = 0;
   while(buttonBar[i])
      delete buttonBar[i++];

   if(toolbar)
   {  // remove all buttons
      for(int i=0;i<99;i++)
         toolbar->removeItem(TOOLBUTTON + i*10);
   }
   else
   {
      toolbar = new KToolBar(this,"myToolBar",36);
      addToolBar(toolbar);
      connect(toolbar,SIGNAL(clicked(int)),SLOT(toolButtonPressed(int)));
      connect(toolbar,SIGNAL(moved(BarPosition)),SLOT(toolBarMoved()));
      connect(menuBar(),SIGNAL(moved(menuPosition)),SLOT(menuBarMoved()));
//////////////////////////////////////////////////////////////////////////////////////////////////7	
	    toolBarHeight = config->readNumEntry("toolbarheight",36);
    	menuBarHeight = config->readNumEntry("menubarheight",25);

    	if(toolBarHeight == 0)
    	{
        toolbar->setBarPos(KToolBar::BarPosition(4));
        toolbar->show();
    	}
    	if(toolBarHeight == 10)
    	{
    	  toolbar->setBarPos(KToolBar::BarPosition(0));
    	  toolBarHeight = 36;
//    	  toolbar->setFlat(true);
// RENE
// Schau Dir das mal an Rene weil folgendes
// wenn die Hhe gleich NULL dann heisst das, das dir Bar flach ist
// aber der macht diese Funktion nicht. Bei der menuBar geht das aber ??!!!    	
    	}
    	
    	if(menuBarHeight == 0)
    	{
        menuBar()->setMenuBarPos(KMenuBar::menuPosition(2));
        menuBar()->show();
    	}
    	if(menuBarHeight == 10)
    	{
    	  menuBar()->setFlat(true);
    	}
/////////////////////////////////////////////////////////////////////////////////////////////////////
   }

// read in the configurated toolbuttons
// now we do a loop start with 0
// read in
//    btImage##
//    btExec##
//    btParam##
//    btTooltip

   int button = 0;      // begin with button 0
   bool ready = false;  // the READY-Flag
   QString s,Image, Exec, Param, Tooltip;
   while(!ready)
   {
		config->setGroup("Toolbuttons");
      // if no button follows we set ready to TRUE
      s.sprintf("btImage%d",button);
   	Image = config->readEntry(s,"");

      s.sprintf("btExec%d",button);
   	Exec = config->readEntry(s,"");

      s.sprintf("btParam%d",button);
   	Param = config->readEntry(s,"");

      s.sprintf("btTooltip%d",button);
   	Tooltip = config->readEntry(s,"");
   	
   	if(Image == "")
   	{
   	   ready = true;
   	}
   	else
   	{
   	   // add new Button
      	KIconLoader kil;
      	QPixmap pm = kil.loadIcon(Image,32,32);

        toolbar->insertButton(pm, TOOLBUTTON + button*10, true, Tooltip );
        buttonBar[button] = new toolButtonInfo;
        buttonBar[button]->btImagePath  = Image;
        buttonBar[button]->btExec       = Exec;
        buttonBar[button]->btParam      = Param;
        buttonBar[button]->btToolTip    = Tooltip;
   	}
   	button++;
   }


  if((button == 1) && !config->hasKey("btImage0"))
  {
  	   // if we found 0 toolbars, we install a standard toolbar
  	   KIconLoader kil;
//  	   QString d = kapp->kde_icondir() + "/";
	config->setGroup("Toolbuttons");

   buttonBar[0] = new toolButtonInfo;
   buttonBar[0]->btImagePath  = "network2.xpm";
   buttonBar[0]->btExec       = "cmdNETWORK";
   buttonBar[0]->btParam      = "";
   buttonBar[0]->btToolTip    = i18n("Read Directory of the private network");
   config->writeEntry("btImage0",  buttonBar[0]->btImagePath);
   config->writeEntry("btExec0" ,  buttonBar[0]->btExec);
   config->writeEntry("btParam0",  buttonBar[0]->btParam);
   config->writeEntry("btTooltip0",buttonBar[0]->btToolTip);
   toolbar->insertButton(kil.loadIcon("network2.xpm"), TOOLBUTTON, true, buttonBar[0]->btToolTip);

   buttonBar[1] = new toolButtonInfo;
   buttonBar[1]->btImagePath  = "sys3.xpm";
   buttonBar[1]->btExec       = "cmdREAD_DIR";
   buttonBar[1]->btParam      = "";
   buttonBar[1]->btToolTip    = i18n("Read Directory of your root-directory");
   config->writeEntry("btImage1",  buttonBar[1]->btImagePath);
   config->writeEntry("btExec1" ,  buttonBar[1]->btExec);
   config->writeEntry("btParam1",  buttonBar[1]->btParam);
   config->writeEntry("btTooltip1",buttonBar[1]->btToolTip);
   toolbar->insertButton(kil.loadIcon("sys3.xpm"), TOOLBUTTON, true, buttonBar[1]->btToolTip);

   buttonBar[2] = new toolButtonInfo;
   buttonBar[2]->btImagePath  = "kcommander.xpm";
   buttonBar[2]->btExec       = "cmdQUIT";
   buttonBar[2]->btParam      = "";
   buttonBar[2]->btToolTip    = i18n("Quit the KCommander");
   config->writeEntry("btImage2",  buttonBar[2]->btImagePath);
   config->writeEntry("btExec2" ,  buttonBar[2]->btExec);
   config->writeEntry("btParam2",  buttonBar[2]->btParam);
   config->writeEntry("btTooltip2",buttonBar[2]->btToolTip);
   toolbar->insertButton(kil.loadIcon("kcommander.xpm"), TOOLBUTTON+10, true, buttonBar[2]->btToolTip);

   config->sync();

  }
   startTimer(500);
}

//ARNO
void KCommanderApp::toolBarMoved()
{
  if(toolbar->barPos() == 1 ||toolbar->barPos() == 2||toolbar->barPos() == 3)
  {
    toolbar->setBarPos((KToolBar::BarPosition)0);
    return;
  }
  KConfig *config;
	config = kapp->getConfig();
  config->setGroup("Bars");

  if(toolbar->barPos() == 4)
    toolBarHeight = 0;
  if(toolbar->barPos() == 5)
    if(menuBar()->menuBarPos() == 3)
    toolBarHeight = 1;
    else
    toolBarHeight = 10;
  if(toolbar->barPos() == 0)
    toolBarHeight = 36;

  config->writeEntry("toolbarheight",toolBarHeight);
  config->writeEntry("menubarheight",menuBarHeight);
  config->sync();
  resizeEvent((QResizeEvent*)NULL);
}

void KCommanderApp::menuBarMoved()
{
  if(menuBar()->menuBarPos() == 1)
  {
    menuBar()->setMenuBarPos((KMenuBar::menuPosition)0);
    return;
  }
  KConfig *config;
	config = kapp->getConfig();
  config->setGroup("Bars");

  if(menuBar()->menuBarPos() == 2)
    menuBarHeight = 0;
  if(menuBar()->menuBarPos() == 3)
    if(toolbar->barPos() == 5)
    menuBarHeight = 1;
    else
    menuBarHeight = 10;
  if(menuBar()->menuBarPos() == 0)
    menuBarHeight = 25;

  config->writeEntry("toolbarheight",toolBarHeight);
  config->writeEntry("menubarheight",menuBarHeight);
  config->sync();
  resizeEvent((QResizeEvent*)NULL);
}
//ARNO

void KCommanderApp::init()
{

// ************************************************************************************
//								die beiden Balken die ber den Listviews sind
// ************************************************************************************
    leftSelLabel = new QLabel(this);
    rightSelLabel = new QLabel(this);

// ************************************************************************************
//								die kleine blaue Diskette
// ************************************************************************************
    QPixmap *pm = new QPixmap((const char **)mini);
		setIcon(*pm);
	
// ************************************************************************************
// 								ColorGroup fr aktiven dirPathButton
// ************************************************************************************
// ColorGroup fr aktiven dirPathButton
	cg1 = new QColorGroup(  QColor(0,0,0),//const QColor & foreground,
							QColor(0,0,180),
							QColor(0xf0,0xf0,0xf0),//const QColor & light,
							QColor(0x30,0x30,0x30),//const QColor & dark,
							QColor(0xc0,0xc0,0xc0),//const QColor & mid,
							QColor(0xf0,0xf0,0xf0),//const QColor & text,
							QColor(0xc0,0xc0,0xc0)//const QColor & base )
							);
// ColorGroup fr deaktiven dirPathButton
	cg2 = new QColorGroup(  QColor(0,0,0),//const QColor & foreground,
							backgroundColor(),//const QColor & background,
							QColor(0xf0,0xf0,0xf0),//const QColor & light,
							QColor(0x30,0x30,0x30),//const QColor & dark,
							QColor(0xc0,0xc0,0xc0),//const QColor & mid,
							QColor(0,0,0),//const QColor & text,
							QColor(0xc0,0xc0,0xc0)//const QColor & base )
							);
	leftDirButton =  new QPushButton(leftDirPath,this,"dbtLeft");
	rightDirButton = new QPushButton(rightDirPath,this,"dbtRight");
	
	leftDirButton ->setPalette(QPalette(*cg2,*cg2,*cg2));
	rightDirButton->setPalette(QPalette(*cg2,*cg2,*cg2));
	leftDirButton ->setFocusPolicy(NoFocus);
	rightDirButton->setFocusPolicy(NoFocus);
	connect(leftDirButton,SIGNAL(clicked()),SLOT(activateLeftLV()));
	connect(rightDirButton,SIGNAL(clicked()),SLOT(activateRightLV()));

// ************************************************************************************
//								die beiden Listviews erstellen
// ************************************************************************************
	linkerListView = new listView(10,10,300,450,this,"lv1");
	rechterListView = new listView(320,10,300,400,this,"lv2");
	connect(linkerListView,SIGNAL(itemSelected(const char *,const char *)),SLOT(itemSelected()));
	connect(linkerListView,SIGNAL(itemDeSelected(const char *,const char *)),SLOT(itemDeSelected(const char *,const char *)));
	connect(linkerListView,SIGNAL(itemClicked(const char *,const char *)),SLOT(itemClicked(const char *,const char *)));
	connect(linkerListView,SIGNAL(itemDoubleClicked(const char *,const char *)),SLOT(itemDoubleClicked(const char *,const char *)));
	connect(linkerListView,SIGNAL(gotFocus()),SLOT(LVgotFocus()));
	connect(linkerListView,SIGNAL(lostFocus()),SLOT(LVlostFocus()));
	connect(linkerListView,SIGNAL(keyPressed(const char *)),SLOT(LVkeyPressed(const char *)));
	connect(linkerListView,SIGNAL(columsChanged()),SLOT(LVcolums()));
	
	connect(rechterListView,SIGNAL(itemSelected(const char *,const char *)),SLOT(itemSelected()));
	connect(rechterListView,SIGNAL(itemDeSelected(const char *,const char *)),SLOT(itemDeSelected(const char *,const char *)));
	connect(rechterListView,SIGNAL(itemClicked(const char *,const char *)),SLOT(itemClicked(const char *,const char *)));
	connect(rechterListView,SIGNAL(itemDoubleClicked(const char *,const char *)),SLOT(itemDoubleClicked(const char *,const char *)));
	connect(rechterListView,SIGNAL(gotFocus()),SLOT(LVgotFocus()));
	connect(rechterListView,SIGNAL(gotFocus()),SLOT(LVlostFocus()));
	connect(rechterListView,SIGNAL(keyPressed(const char *)),SLOT(LVkeyPressed(const char *)));
	connect(rechterListView,SIGNAL(columsChanged()),SLOT(LVcolums()));
	
	
// ************************************************************************************
//								Label & Eingabezeile
// ************************************************************************************
	commandLineLabel = new QLabel(this,"kommandolabel");
	commandLineLabel->setAlignment(AlignRight);
	commandLineLabel->setFocusPolicy(NoFocus);
	commandBox = new QComboBox(true,this,"kommandobox");
	commandBox->setFocusPolicy(ClickFocus);
	connect(commandBox,SIGNAL(activated(const char *)),SLOT(commandBoxActivated()));

// ************************************************************************************
//								die untere Buttonleiste erstellen
// ************************************************************************************
	
	QString s;
	for(int i=0;i<7;i++)
	{
		s.sprintf("bt%d",i);
		buttonLeiste[i] = new QPushButton("",this,s);
		buttonLeiste[i]->setFocusPolicy(NoFocus);
		buttonLeiste[i]->setStyle(WindowsStyle);
		if(i<6)connect(buttonLeiste[i], SIGNAL(clicked()), this, SLOT(buttonLeistePressed()));
	}
	connect(buttonLeiste[6],SIGNAL(clicked()),kapp,SLOT(appHelpActivated()));
	
  buttonLeiste[0]->setAccel(Key_F3);
  buttonLeiste[1]->setAccel(Key_F4);
  buttonLeiste[2]->setAccel(Key_F5);
  buttonLeiste[3]->setAccel(Key_F6);
  buttonLeiste[4]->setAccel(Key_F7);
  buttonLeiste[5]->setAccel(Key_F8);
  buttonLeiste[6]->setAccel(Key_F9);
  	
	buttonLeiste[0]->setText(i18n("F3 Show"));
	buttonLeiste[1]->setText(i18n("F4 Edit"));
	buttonLeiste[2]->setText(i18n("F5 Copy"));
	buttonLeiste[3]->setText(i18n("F6 Move"));
	buttonLeiste[4]->setText(i18n("F7 MkDir"));
	buttonLeiste[5]->setText(i18n("F8 Delete"));
	buttonLeiste[6]->setText(i18n("F9 Help"));

// ************************************************************************************
//								die Mens erstellen
// ************************************************************************************

      popup0 = new QPopupMenu;
      popup1 = new QPopupMenu;
      popup2 = new QPopupMenu;
      popup3 = new QPopupMenu;
      popup3->setCheckable(true);
      popup4 = new QPopupMenu;
      popup5 = new QPopupMenu;
      popup6 = new QPopupMenu;
      
      int id;
      id = popup0->insertItem(i18n("&Change Attributes..."), this, SLOT(menuPressed()), 0, ID_MENU_ATTRIBUTES );
      id = popup0->insertItem(i18n("C&ompress..."),this,SLOT(menuPressed()), Key_F5+ALT, ID_MENU_PACK );
      id = popup0->insertItem(i18n("&Decompress..."),this,SLOT(menuPressed()), Key_F9+ALT, ID_MENU_UNPACK );
//      popup0->setItemEnabled(id,false);
      id = popup0->insertItem(i18n("&Test Archieve(s)..."),this,SLOT(menuPressed()), 0, ID_MENU_TESTARC );
      popup0->setItemEnabled(id,false);
      id = popup0->insertItem(i18n("&Symlinks..."),this,SLOT(menuPressed()), 0, ID_MENU_MAKELINK );
      popup0->setItemEnabled(id,false);
      id = popup0->insertItem(i18n("Properties..."),this,SLOT(menuPressed()), 0, ID_MENU_FILEATTR );
      popup0->setItemEnabled(id,false);
      id = popup0->insertItem(i18n("&Get Diskspace..."),this,SLOT(menuPressed()), 0, ID_MENU_GETMEM );
      popup0->setItemEnabled(id,false);
      id = popup0->insertItem(i18n("&Print"),this,SLOT(menuPressed()), 0, ID_MENU_PRINT );
      popup0->setItemEnabled(id,false);
      popup0->insertSeparator();
      id = popup0->insertItem(i18n("Sp&lit Files..."),this,SLOT(menuPressed()), 0, ID_MENU_SPLITFILE );
      id = popup0->insertItem(i18n("&Join Files..."),this,SLOT(menuPressed()), 0, ID_MENU_JOINFILE );
      id = popup0->insertItem(i18n("&Code Files (MIME, UUE, XXE )..."),this,SLOT(menuPressed()), 0, ID_MENU_CODING );
      popup0->setItemEnabled(id,false);
      id = popup0->insertItem(i18n("Decode Files (MIME, UUE, XXE, BinHex)..."),this,SLOT(menuPressed()), 0, ID_MENU_DECODING );
      popup0->setItemEnabled(id,false);
      popup0->insertSeparator();
      id = popup0->insertItem(i18n("E&xit..."),this,SLOT(menuPressed()), Key_F4+ALT, ID_MENU_EXIT );
      id = popup1->insertItem( i18n("&Mark Group..."), this, SLOT(menuPressed()), Key_Plus, ID_MENU_MARKGROUP );
      id = popup1->insertItem( i18n("&Unmark Group..."), this, SLOT(menuPressed()), Key_Minus, ID_MENU_REMARKGROUP );
      id = popup1->insertItem( i18n("Mark All Files"), this, SLOT(menuPressed()), 0, ID_MENU_MARKALL );
      id = popup1->insertItem( i18n("Unmark All Files"), this, SLOT(menuPressed()), 0, ID_MENU_MARKNONE );
      id = popup1->insertItem( i18n("Reverse Selection"), this, SLOT(menuPressed()), 0, ID_MENU_MARKREVERSE );
      popup1->insertSeparator();
      id = popup1->insertItem( i18n("Compare Directorys"), this, SLOT(menuPressed()) );
      popup1->setItemEnabled(id,false);
      id = popup1->insertItem( i18n("Mark New, Hide Same"), this, SLOT(menuPressed()) );
      popup1->setItemEnabled(id,false);
      
      id = popup2->insertItem( i18n("&CD-Directory Tree..."),
                                                            this, SLOT(menuPressed()) );
      popup2->setItemEnabled(id,false);
      id = popup2->insertItem( i18n("&Search..."),          this, SLOT(menuPressed()), Key_F7+ALT, ID_MENU_SEARCHFILE );
      id = popup2->insertItem( i18n("System &Information..."),
                                                            this, SLOT(menuPressed()),0,ID_MENU_SYSINFO );
      id = popup2->insertItem( i18n("&Treelist"),           this, SLOT(menuPressed()),0,ID_MENU_TREELIST );
//      popup2->setItemEnabled(id,false);
      id = popup2->insertItem( i18n("&Back"),               this, SLOT(menuPressed()) );
      popup2->setItemEnabled(id,false);
      popup2->insertSeparator();
      id = popup2->insertItem( i18n("&Start A Shell"),      this, SLOT(menuPressed()),Key_X + CTRL,ID_MENU_STARTTERM );
      popup2->insertSeparator();

      id = popup2->insertItem( i18n("Format Disk"),         this, SLOT(menuPressed()),0,ID_MENU_FORMAT );
      popup2->insertSeparator();

      id = popup2->insertItem( i18n("&Network"),            this, SLOT(menuPressed()),Key_N + CTRL,ID_MENU_NETWORK );
      popup2->insertSeparator();

      id = popup2->insertItem( i18n("Mount SMB-Drives..."), this, SLOT(menuPressed()) );
      popup2->setItemEnabled(id,false);
      id = popup2->insertItem( i18n("Umount SMB-Drives..."),this, SLOT(menuPressed()) );
      popup2->setItemEnabled(id,false);
      popup2->insertSeparator();
      id = popup2->insertItem( i18n("FT&P-Connection..."),
                                                            this, SLOT(menuPressed()) );
      popup2->setItemEnabled(id,false);
      id = popup2->insertItem( i18n("FTP &New Connection..."),
                                                            this, SLOT(menuPressed()) );
      popup2->setItemEnabled(id,false);
      id = popup2->insertItem( i18n("FTP-Close Connection..."),
                                                            this, SLOT(menuPressed()) );
      popup2->setItemEnabled(id,false);
      id = popup2->insertItem( i18n("FTP-View Hidden Files..."),
                                                            this, SLOT(menuPressed()) );
      popup2->setItemEnabled(id,false);
      popup2->insertSeparator();
      id = popup2->insertItem( i18n("&Swap Listviews"),     this, SLOT(menuPressed()),Key_U + CTRL,ID_MENU_SWAPLISTVIEWS );
      id = popup2->insertItem( i18n("Adjust Listviews "),   this, SLOT(menuPressed()) );
      popup2->setItemEnabled(id,false);

      id = popup3->insertItem( i18n("&Short"),              this, SLOT(menuPressed()) );
      popup3->setItemEnabled(id,false);
      id = popup3->insertItem( i18n("&Long"),               this, SLOT(menuPressed()) );
      popup3->setItemEnabled(id,false);
      id = popup3->insertItem( i18n("&Directory Tree"),     this, SLOT(menuPressed()) );
      popup3->setItemEnabled(id,false);
      id = popup3->insertItem( i18n("Fast View"),           this, SLOT(menuPressed()) );
      popup3->setItemEnabled(id,false);
      id = popup3->insertItem( i18n("Drivespace"),          this, SLOT(menuPressed()),Key_L + CTRL,ID_MENU_DRIVESPACE );
      popup3->insertSeparator();
      id = popup3->insertItem( i18n("&All"),                this, SLOT(menuPressed()) );
      popup3->setItemEnabled(id,false);
      id = popup3->insertItem( i18n("&Programms"),          this, SLOT(menuPressed()) );
      popup3->setItemEnabled(id,false);

      id = popup3->insertItem( i18n("Show Dirs"),           this, SLOT(menuPressed()),Key_1 + SHIFT, ID_MENU_SHOW_DIRS );
      id = popup3->insertItem( i18n("Show Files"),          this, SLOT(menuPressed()),Key_2 + SHIFT, ID_MENU_SHOW_FILES );
      id = popup3->insertItem( i18n("Show Hidden"),         this, SLOT(menuPressed()),Key_3 + SHIFT, ID_MENU_SHOW_HIDDEN );
      id = popup3->insertItem( i18n("Show Systemfiles"),    this, SLOT(menuPressed()),Key_4 + SHIFT, ID_MENU_SHOW_SYSTEMFILES );

      id = popup3->insertItem( i18n("&User Defined..."),    this, SLOT(menuPressed()) );
      popup3->setItemEnabled(id,false);
      popup3->insertSeparator();
      id = popup3->insertItem( i18n("By &Name"),            this, SLOT(menuPressed()),Key_1 + CTRL,ID_MENU_SORT_NAME);
      id = popup3->insertItem( i18n("By &Size"),            this, SLOT(menuPressed()),Key_2 + CTRL,ID_MENU_SORT_SIZE);
      id = popup3->insertItem( i18n("By &Date/Time"),       this, SLOT(menuPressed()),Key_3 + CTRL,ID_MENU_SORT_DATE);
      id = popup3->insertItem( i18n("&Permissions"),        this, SLOT(menuPressed()),Key_4 + CTRL,ID_MENU_SORT_PERM);
      popup3->insertSeparator();
      id = popup3->insertItem( i18n("Descend Sortorder"),   this, SLOT(menuPressed()) );
      popup3->setItemEnabled(id,false);
      popup3->insertSeparator();
      id = popup3->insertItem( i18n("&Refresh Source"),     this, SLOT(menuPressed()),Key_R + CTRL,ID_MENU_QUELLE );


      id = popup4->insertItem( i18n("&Options..."),         this, SLOT(menuPressed()),0,ID_MENU_OPTIONS);
      id = popup4->insertItem( i18n("Change Buttonbar..."), this, SLOT(menuPressed()),0,ID_MENU_BUTTONBAR );
//      popup4->setItemEnabled(id,false);

//************************************************************************************************************
		

		config->setGroup("Startmenu");
		bool flag = true;
		int i=0;
		while(flag)
		{
			s.sprintf("Menutitle%d",i);
			QString titel = config->readEntry(s,"");
			if(titel == "") break;
			popup5->insertItem(titel,ID_STARTMENU+i);
			i++;
		}
      popup5->insertSeparator();
      id = popup5->insertItem( i18n("Change Start Menu..."),this, SLOT(menuPressed()),0,ID_MENU_STARTER );
      id = popup5->insertItem( i18n("Change Main Menu..."), this, SLOT(menuPressed()) );
      popup5->setItemEnabled(id,false);
      id = popup5->insertItem( i18n("Edit Path Assigns..."),this, SLOT(menuPressed()),0,ID_MENU_ASSIGNS );
//************************************************************************************************************

      id = popup6->insertItem( i18n("About..."), this, SLOT(menuPressed()),0,ID_MENU_HELPABOUT );
      popup6->insertSeparator();
      id = popup6->insertItem(i18n("&Help"),kapp,SLOT(appHelpActivated()),Key_F9,ID_MENU_HELPTHIS);
//			key->changeMenuAccel(	popup6, ID_MENU_HELPTHIS, KAccel::Help );	


		connect(popup0,SIGNAL(activated ( int )),this,SLOT(menuActivated ( int)));
      connect(popup1,SIGNAL(activated ( int )),this,SLOT(menuActivated ( int)));
      connect(popup2,SIGNAL(activated ( int )),this,SLOT(menuActivated ( int)));
      connect(popup3,SIGNAL(activated ( int )),this,SLOT(menuActivated ( int)));
      connect(popup4,SIGNAL(activated ( int )),this,SLOT(menuActivated ( int)));
      connect(popup5,SIGNAL(activated ( int )),this,SLOT(menuActivated ( int)));
      connect(popup6,SIGNAL(activated ( int )),this,SLOT(menuActivated ( int)));
      
      menuBar()->insertItem(i18n("&Files"), popup0 );
      menuBar()->insertItem(i18n("&Mark"),popup1);
      menuBar()->insertItem(i18n("&Commands"),popup2);
      menuBar()->insertItem(i18n("&View"),popup3);
      menuBar()->insertItem(i18n("&Configuration"),popup4);
      menuBar()->insertItem(i18n("&Start Menu"),popup5);
      menuBar()->insertItem(i18n("&Help"),popup6);

	

// ************************************************************************************
//								die beiden DriveListen erstellen
// ************************************************************************************
		leftDriveList = new QComboBox(  this, "0" );
		  leftDriveList->setFocusPolicy(NoFocus);
		rightDriveList = new QComboBox( this, "1" );	
		  rightDriveList->setFocusPolicy(NoFocus);

		QFile f("/etc/fstab");
		if ( f.open(IO_ReadOnly) ) {    // file opened successfully
			QTextStream t( &f );        // use a text stream
			QString s;
			while ( !t.eof() ) {        // until end of file...
				s = t.readLine();       // line of text excluding '\n'
				s = s.simplifyWhiteSpace();
				if(s.at(0) == '/')
				{
					if(s.find("SwAP",0,false) == -1)
					{
						// in S msste jetzt nur ein Device stehen, was auch Datentrger ist
						// zuerst mal das erste Leerzeichen finden
						int z = s.find(" /");		// nach Leerzeichen suchen
						if(z == -1)							// wenn z immernoch -1, dann raus hier !
						 break;
						s = s.right(s.length()-z-1);
						z = s.find(" ");
						if( z == -1)
						 break;
						s = "[" + s.left(z) + "]";
						leftDriveList->insertItem(s);
						rightDriveList->insertItem(s);
					}
				}
			}
			f.close();
		}
	leftDriveList->insertItem("[//]");
	rightDriveList->insertItem("[//]");
	connect(leftDriveList,SIGNAL( activated( const char * )),SLOT(driveActivated (const char * )));
	connect(rightDriveList,SIGNAL(activated( const char * )),SLOT(driveActivated (const char * )));
	readOptions();
	linkerListView->setFocus();
}

void KCommanderApp::resizeEvent(QResizeEvent *t)
{
//	cerr << menuBar()->height();
	int breite = (width()-15)/7;

	// buttons beside the drivelist's
	leftDirButton->setGeometry(110,9+toolBarHeight+menuBarHeight,(width()/2)-15-100,20);
	rightDirButton->setGeometry((width()/2)+5+100,9+toolBarHeight+menuBarHeight,(width()/2)-15-100,20);
	
	// the listview's
	linkerListView->setGeometry(10,34+toolBarHeight+menuBarHeight,(width()/2)-15,height()-114-toolBarHeight-menuBarHeight);
	rechterListView->setGeometry((width()/2)+5,34+toolBarHeight+menuBarHeight,(width()/2)-15,height()-114-toolBarHeight-menuBarHeight);
	
	// the pathlabel below the left listview
	commandLineLabel->setGeometry(10,height()-52,linkerListView->width(),20);
	
	// the buttons below the listview's
	for(int i=0;i<7;i++)
		buttonLeiste[i]->setGeometry(10+i*breite,height()-27,breite,25);
	
	// fileselectionlabels below the listviews
	leftSelLabel->setGeometry(10,height()-80,(width()/2)-15,20);
	rightSelLabel->setGeometry((width()/2)+5,height()-80,(width()/2)-15,20);
	
	// the commandbox
	commandBox->setGeometry(width()/2,height()-55,width()/2-10,20);
	
	// the 2 drivelistboxes
	leftDriveList->setGeometry(10,9+toolBarHeight+menuBarHeight,95,20);
	rightDriveList->setGeometry((width()/2)+5,9+toolBarHeight+menuBarHeight,95,20);
   if(driveSpace)
   {
      if(listWithFocus == linkerListView)
         driveSpace->setGeometry(rechterListView->x(),listWithFocus->y(),listWithFocus->width(),listWithFocus->height());
      else
         driveSpace->setGeometry(linkerListView->x(),listWithFocus->y(),listWithFocus->width(),listWithFocus->height());
   }
}


void	KCommanderApp::writeRecursiveList(QFile *f, const char *Dirname,int cut)
{
//OK  
	QString q;
	q = Dirname;
  QDir d(q);
	d.setFilter( QDir::Dirs | QDir::Files | QDir::Hidden | QDir::NoSymLinks );

	const QFileInfoList *list = d.entryInfoList();
	QFileInfoListIterator it( *list );      // create list iterator
	QFileInfo *fi;                          // pointer for traversing

	while ( (fi=it.current()) )
	{
		if((fi->fileName() != "..") && (fi->fileName() != "."))
		{
			if(fi->isDir())
			{
				QString t(Dirname);
				t += "/";
				t += fi->fileName();
				//recursiv weiter rein !
				writeRecursiveList(f,t,cut);
			}
			else
			{
				QString d2(Dirname);
				d2 += "/";
				d2 += fi->fileName();
				d2 += "\n";
				d2 = d2.right(d2.length()-cut);
				convert(&d2);
				f->writeBlock(d2,strlen(d2));
			}
		}
	
	++it;                               // goto next list element
  }
	
}
void	KCommanderApp::convert(QString * kette)
{ //vor jedes " " ein "\" hngen

	int p=0;
	for(int i=0;i<(signed)strlen(*kette);i++)
	{
		if(kette->mid(p,1) == " ")
			kette->insert(p++,"\\");
		p++;
	}
}

void	KCommanderApp::closeEvent ( QCloseEvent * e )
{
	if(optionen::askExit())
	{
	   if(QMessageBox::warning( this,  i18n("System"),i18n("Exit KCommander ??\n"),i18n("&Yes"),"&Cancel",0, 1 ) == 1)
				return;
	}
	saveOptions();
	e->accept();
	
}

unsigned int KCommanderApp::getDirSize(QString pfad,const unsigned int size=0)
{
		unsigned int mySize = size;
		QDir d(pfad);
		d.setSorting(QDir::Name | QDir::DirsFirst | QDir::IgnoreCase);
		d.setFilter(QDir::Files | QDir::Dirs | QDir::Hidden);

if ( d.isReadable() )
{	
   const QFileInfoList * files = d.entryInfoList();
   if ( files ) {
      QFileInfoListIterator it( *files );
      QFileInfo * f;
      
      while( (f=it.current()) != 0 ) {
         ++it;
         if ( f->fileName() == "." || f->fileName() == ".." )
         {
         }
         else
         {
          if ( f->isDir())
            {
          		mySize = getDirSize(pfad + f->fileName() + "/",mySize);
            }
         else
            {
              mySize += f->size() ;
            }
         }
			}
			return mySize;
		}
}

}

void	KCommanderApp::exec(const char *t)
{
					KProcess proc;
					proc << "xterm" << "-e" << t;
					proc.start(KProcess::DontCare,KProcess::All);
}



char * KCommanderApp::upDir(const char *ss)
{
	char *s = (char *)ss;
  for(int i = strlen(s)-2;i > -1;i--)
  {
  		if(s[i] == '/')
  			{
 				s[i+1] = 0;
 				return s;
  			}
  }
	return s;
}


void	KCommanderApp::focusInEvent ( QFocusEvent *e )
{
}


void KCommanderApp::dirviewItemSelected(const char *path)
{
	listView *lv;
	
	if(rechterListView->isVisible())
	{
		lv = rechterListView;
		rightDirPath = path;
		rightDirButton->setText(path);
	}
	else
	{
		lv = linkerListView;
		leftDirPath = path;
		leftDirButton->setText(path);
	}
	readDir(path,lv);
}

void KCommanderApp::timerEvent(QTimerEvent *e)
{
//	QString s;
//	s.sprintf("%d",(int)toolbar->barPos());
//	debug(s);
}
void KCommanderApp::commandCallback(int i)
{
}
void KCommanderApp::activateLeftLV()
{
   linkerListView->setFocus();
}
void KCommanderApp::activateRightLV()
{
   rechterListView->setFocus();
}

