#ifndef KCOMMANDER_H
#define KCOMMANDER_H
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// include files for KDE
#include <kapp.h>
#include <ktmainwindow.h>
#include <kaccel.h>
#include <ktoolbar.h>
#include <kprocess.h>
#include <kiconloader.h>

// include files for QT
#include <qpixmap.h>
#include <qmessagebox.h>
#include <qdir.h>

// include files of project
#include "listview.h"
#include "dlgshow.h"
#include "dlgcopy2.h"
#include "dlgmove.h"
#include "dlgdel.h"
#include "dlgoptions.h"
#include "inputbox.h"
#include "aboutwindow.h"
#include "optionen.h"
#include "dlgpermissions.h"
#include "dlgfind.h"
#include "dlgsysinfo.h"
#include "dlgstartmenu.h"
#include "dlgsplit.h"
#include "dlgjoin.h"
#include "dlgkcsinfo.h"
#include "dirview.h"
#include "dlgextract.h"
#include "dlgedittoolbar.h"
#include "dlgeditassigns.h"
#include "wdgdrivespace.h"

// forward declaration of the KCommander classes

struct kcsHeader{
		char		header[4];
		uint		fSize;
		int		permissions;
		int		ownerID;
		int		groupID;
		char		future[256];		// falls noch andere Infos reinmuessen
};

class KCommanderApp : public KTMainWindow
{
  Q_OBJECT


public:
  KCommanderApp();
  ~KCommanderApp();
	void 					saveOptions();
	void 					readOptions();
	bool              SMB_MOUNT_SHARE;
	bool              SMB_READY;
	int               SMB_ERROR;
	QLabel *l1,*l2,*l3,*l4,*l5,*l6,*l7,*l8,*l9,*l0;
	QWidget           *ausgabefenster;
	KConfig				*config;
	KAccel				*key_accel;
	KToolBar          *toolbar;
//*************************************************
//	Class-Subroutinen
//*************************************************
	void 					initKeyAccel();
	void 					initMenuBar();
	void 					initMyToolBar();
//	void 					initStatusBar();
	void 					init();
	void 					enableCommand(int);
	void 					disableCommand(int);
	void					writeRecursiveList(QFile *, const char *,int);
	void					convert(QString *);
	unsigned int 		getDirSize(QString,const unsigned int size=0);
	void					exec(const char *);
	void					mimeExec(const char *t);
	char 					*upDir(const char *);
	void 					insertParam(QString ,KShellProcess *);
   void              fillDriveAssigns(QPopupMenu *menu);       // fill the popupmenu on pressing SHIFT+F1 or F2
                                                               // with the assigned paths
   void              readDir(const char *pathname, listView *lv);
   void              swapItems(struct listItem *i1,struct listItem *i2);
   void              autoUmount(const char *pathname);
   void              autoMount(const char *pathname);
   char *            netPathToRealPath(const char * path);
   bool              isMounted(const char *pathname);
   void              updateToolbar();
//*************************************************
//	Class-Variablen
//*************************************************
QLabel					*leftSelLabel,			// xx/xx Files selected
      					*rightSelLabel,
      					*commandLineLabel;	// path of the commandline
QComboBox				*commandBox,
							*leftDriveList,
							*rightDriveList;
QColorGroup 			*cg1,						// the two colorgroups of the
							*cg2;						// DirButtons
QPushButton				*buttonLeiste[7];

QPopupMenu				*popup0,
							*popup1,
							*popup2,
							*popup3,
							*popup4,
							*popup5,
							*popup6;
QPushButton				*leftDirButton,
							*rightDirButton;
QString					leftDirPath,
							rightDirPath;
listView					*linkerListView,
							*rechterListView,
							*listWithFocus;
dirview					*dirListBox;
bool						eingehangen;
bool						error;
wdgDriveSpace        *driveSpace;

QPixmap 		      *foldericon;
QPixmap 		      *fileicon;
QPixmap 		      *linkicon;
QPixmap 		      *folderlinkicon;
QPixmap 		      *upicon;
QPixmap 		      *kcsicon;
QPixmap 		      *archiveicon;
QPixmap 		      *msexeicon;
QPixmap 		      *network1Icon,
                  *network2Icon,
                  *network3Icon,
                  *dragicon;
int               countChars(const char *string, char z);
void              updateFilterFromMenu();
void              updateMenuFromFilter();
toolButtonInfo    *buttonBar[99];
int               toolBarHeight,menuBarHeight;

protected:

private slots:
	void 					resizeEvent(QResizeEvent *);
	void 					itemSelected();
	void 					itemDeSelected(const char *,const char *);
	void 					itemClicked(const char *,const char *);
	void 					itemDoubleClicked(const char *,const char *);
	void 					LVgotFocus();
	void 					LVlostFocus();
	void 					LVkeyPressed(const char *);
	void					menuActivated(int);
	void					menuPressed();
	void					buttonLeistePressed();
	void					driveActivated(const char *);
	void					LVcolums();
	void					commandBoxActivated();
	void					slotExamine(KProcess *);
	void					receivedStdout (KProcess *, char *, int);
	void					receivedStderr (KProcess *, char *, int);
	void					focusInEvent ( QFocusEvent * );
	void					dirviewItemSelected(const char *path);
  void              commandCallback(int i);
  void              drivePopupActivated ( int itemId );
  void              activateRightLV();
  void              activateLeftLV();
  void              slotSMBmount(KProcess *proc, char *buffer, int bufferlen);
  void              toolButtonPressed(int);
  void              toolBarMoved();
  void              menuBarMoved();
public slots:
	void					closeEvent ( QCloseEvent *);
	void              timerEvent(QTimerEvent *);
};
 
#endif // KCOMMANDER_H
