
#include "wdgdrivespace.h"
#include <kapp.h>
#include <qpainter.h>
#include <iostream.h>
#include <stdlib.h>
#include "kcommander.h"

wdgDriveSpace::wdgDriveSpace(listView *l, QWidget *parent, const char *name ) : QWidget(parent,name) {

   main = parent;
   prozent = 0;
   lv = l;
   setPath(lv->dirPath);

   l1 = new QLabel(this);
   l1->setText(i18n("actual path:"));
   l1->setGeometry(20,20,200,30);

   l2 = new QLabel(this);
   l2->setText(i18n("drive hardlink:"));
   l2->setGeometry(20,45,200,30);

   l3 = new QLabel(this);
   l3->setText(i18n("filesystem:"));
   l3->setGeometry(20,70,200,30);

   l4 = new QLabel(this);
   l4->setText(i18n("size of drive:"));
   l4->setGeometry(20,95,200,30);

   l5 = new QLabel(this);
   l5->setText(i18n("drive used:"));
   l5->setGeometry(20,120,200,30);

   l6 = new QLabel(this);
   l6->setText(i18n("drive free:"));
   l6->setGeometry(20,145,200,30);

   l7 = new QLabel(this);
   l7->setText(i18n("Percentage:"));
   l7->setGeometry(20,170,200,30);


   lb1 = new QLabel(this);
   lb1->setGeometry(220,20,200,30);

   lb2 = new QLabel(this);
   lb2->setGeometry(220,45,200,30);

   lb3 = new QLabel(this);
   lb3->setGeometry(220,70,100,30);

   lb4 = new QLabel(this);
   lb4->setGeometry(220,95,100,30);

   lb5 = new QLabel(this);
   lb5->setGeometry(220,120,100,30);

   lb6 = new QLabel(this);
   lb6->setGeometry(220,145,100,30);

   lb7 = new QLabel(this);
   lb7->setGeometry(220,170,100,30);

   me = new QMultiLineEdit(this);

   startTimer(500);
   showInfoFile();
}
wdgDriveSpace::~wdgDriveSpace()
{
}
void wdgDriveSpace::setPath(const char *p)
{
   path = p;
}
void wdgDriveSpace::timerEvent(QTimerEvent *e)
{
   KCommanderApp *m = (KCommanderApp *)main;
   setPath(m->netPathToRealPath(lv->dirPath));
   lb1->setText(path);

	KShellProcess proc;
	proc << "df -T -h";
	QApplication::connect(&proc, SIGNAL(processExited(KProcess *)),this, SLOT(slotExamine()));
	QApplication::connect(&proc, SIGNAL(receivedStdout(KProcess *, char *, int)), this, SLOT(receivedStdout(KProcess *, char *, int)));
	QApplication::connect(&proc, SIGNAL(receivedStderr(KProcess *, char *, int)), this, SLOT(receivedStderr(KProcess *, char *, int)));
	ready = false;
	
	proc.start(KProcess::Block,KProcess::All);
	while(!ready)
		kapp->processEvents();	// solange in Schleife bleiben, wie nextFile = false
   draw();
   // save Infofile

   QString infoFile(m->netPathToRealPath(lv->dirPath));
   infoFile += ".kcminfo";
   QFile ifile(infoFile);
   if(ifile.open(IO_WriteOnly))
   {
      for(int i = 0; i< me->numLines(); i++)
      {
         QString t = me->textLine(i) + QString("\n");
         ifile.writeBlock(t,t.length());
      }
      ifile.close();
   }
}
void wdgDriveSpace::showInfoFile()
{
   KCommanderApp *m = (KCommanderApp *)main;
   QString infoFile(m->netPathToRealPath(lv->dirPath));
   infoFile += ".kcminfo";
   QFile ifile(infoFile);

   me->clear();
   if(ifile.open(IO_ReadOnly))
   {
      char zeile[1024];
      QString z;
      while(!ifile.atEnd())
      {
         ifile.readLine(zeile,200);
         z = zeile;
         z = z.left(z.length()-1);
         me->append(z);
      }
      ifile.close();
   }
}
void wdgDriveSpace::slotExamine()
{
   ready = true;
}
void wdgDriveSpace::receivedStdout(KProcess *pro,char *buffer,int buflen)
{
   int z = 0;
   char *b,*bb;
   buffer[buflen] = 0;
   b = strchr(buffer, '/');

ma1:
   zeilen[z++] = b;
   // get end of line
   b = strchr(b,'\n');
   // make a copy of this pointer
   bb = b; b++;
   // b points to the next line
   // cut the EOL of the actual line
   bb[0] = 0;
   // if there a next line ?
   if(b[0] != 0)
      // yes, go back
      goto ma1;

   zeilen[z] = 0;
   // i have to search backward !! because the "/" points to all paths
   // z is the index for the last line
   z--;

   // now find the right line for our path
   QString zeile;
   int p;            // position of founding char
   while(z >= 0)
   {
      zeile = zeilen[z--];
      // delete unusable tab's or spaces
      zeile = zeile.simplifyWhiteSpace();
      p = zeile.find("%") +2;
      QString syspath = zeile.mid(p,200);
      if(path.find(syspath) == 0)
      {
         QString rest = zeile;
         ready = false;
         int zz = 0;
         while(!ready)
         {
            p = rest.find(" ");
            spalten[zz++] = rest.left(p);
            rest = rest.mid(p+1,200);
            if(p == -1)
               ready = true;
         }
         lb2->setText(spalten[0]);
         lb3->setText(spalten[1]);
         lb4->setText(spalten[2]);
         lb5->setText(spalten[3]);
         lb6->setText(spalten[4]);
         int frei = 100 - atoi(spalten[5]);
         QString s;
         s.sprintf("%d%%",frei);
         s += i18n(" free");
         lb7->setText(s);
         s = spalten[5];
         s = s.left(s.length()-1);
         prozent = s.toInt();
         draw();
         break;
      }


   }
}
void wdgDriveSpace::receivedStderr(KProcess *p,char *buffer,int buflen)
{
}
void wdgDriveSpace::paintEvent(QPaintEvent *e)
{
   draw();
}
void wdgDriveSpace::draw()
{
   me->setGeometry(10,250,width()-20,height()-120);
	QPainter p;
	QBrush bblue;
	QBrush bred;
	int a2,a1;
	// 100 % sind 5760
	a2=5760 * prozent / 100;
	a1=5760 -a2;
	int b = 200;
	int h = 100;
	QPixmap *pm = new QPixmap(b,h);
	pm->fill(backgroundColor());
	
	p.begin(pm);

	bred.setColor(blue);
	bred.setStyle(SolidPattern);
	bblue.setStyle(SolidPattern);
	bblue.setColor(cyan);

	p.setPen(blue);
	for (int i=0;i<16;i++)
	   p.drawArc(16,3+i,119,30,0,a1);
	
	p.setPen(cyan);
	for (int i=0;i<16;i++)
	   p.drawArc(16,3+i,119,30,0,-a2);
	
	p.setPen(black);
	for (int i=0;i<16;i++)
	   p.drawArc(16,3+i,119,30,a1,0);
	p.setBrush(bred);
	p.drawPie(15,3,120,30,0,a1);
	p.setBrush(bblue);
	p.drawPie(15,3,120,30,0,-a2);
	p.drawArc(15,18,120,30,0,-2880);
	p.drawLine(15,18,15,33);
	p.drawLine(134,18,134,33);
	p.end();
	bitBlt(this,350,100,pm);
	delete pm;
}
